# --*-- coding:utf-8 --*--
import sys 
import os
import re
from cmd import Cmd
reload(sys) 
sys.setdefaultencoding('utf-8')
path = os.path.dirname(os.path.abspath(__file__))
path = os.path.join(path, "..\\..\\..")
sys.path.append(path)
from common.contentParse import *

global divide
global key_lst  #对应Excel中属性列表
global attribute_arr #从传入的命令中获取的属性列表 
global  value_lst
global context


#对应excel中的属性字段
key_lst  = [
                     'hba_instance', 
                     'hba_model',
                     'wwn',
                     'status'
            ]

#获取Aix主机集群 Server信息
def execute(context):
    #获取回文
    #start
    path = getValueFMap(context,style,'path')
    command = getValueFMap(context,style,'command').strip()
    attribute_arr = []
    value_lst = []
    if ';'== command[-1]:
        command =command[0:-1]
    addValueToMap(context,style,'command',command)
    #{属性名:[对应列表]}
    attrcom_dic = get_attrcom_dic(context)
    #对应execel属性名
    json_attr_name = get_jsonarr_name(attrcom_dic)
    #{属性名:[对应回文的列表]}
    attr_valuelst_dic = get_attrvalue_dic(context,attrcom_dic)
    #获取attribute ,value_lst
    hbaObjlist = []
    hbaObjList = get_hba_instance(attr_valuelst_dic[key_lst[0]])
    for obj in hbaObjList:
        value_lst.append(obj.get_instance())
        value_lst.append(obj.get_model())
        value_lst.append(obj.get_wwn())
        value_lst.append(obj.get_status())
    
    for key in key_lst:
        tempList = []
        for attr in attr_valuelst_dic.keys():
            if key.lower().strip() in attr.lower():
                attribute_arr.append(attr)
    #获取json结果字符串                
    result = get_jsonstr(json_attr_name,attribute_arr, value_lst)
    addValueToMap(context,style,'result',result)
    return context


#功能说明：返回属性名与对应回文列表组成的字典
def get_attrvalue_dic(context,attrcom_dic):
    all_comds_lst = get_purecommands_lst(attrcom_dic)
    path = getValueFMap(context,style,'path')
    all_comds_byfile = get_comdslst_byfile(all_comds_lst,path)
    return get_attrlst_dic(attrcom_dic,all_comds_byfile,path)


#Instance
def get_hba_instance(tempList):
    result = []
    failStr = 'TOOLKIT_EXE_CMD_FAILED'
    hbaObjList = []
    if 0 == len(tempList):
        fail_Obj = Hba_Entity()
        hbaObjList.append(fail_Obj)
        return hbaObjList
    
    for line in tempList:
        if failStr.lower() in line.lower():
            fail_Obj = Hba_Entity()
            hbaObjList.append(fail_Obj)
            return hbaObjList
     
    tempList = tempList[2:-1]
    modelObj = Model_Entity()
    for line in tempList:
        if 'fcs' in line.lower():
            hba_obj = Hba_Entity()
            tempStr = re.split('\\s+', line)
            hba_obj.set_instance(tempStr[0])
        elif 'network address' in line.strip().lower():
            tempLine = line.strip().lower()
            tempLine = tempLine.replace('network address','').replace('.','')
            hba_obj.set_wwn(tempLine)
        elif 'hardware location' in line.strip().lower():
            tempLine = line.strip().lower()
            tempLine = tempLine.replace('hardware location code','').replace('.','')
            hba_obj.set_location(tempLine)
            hbaObjList.append(hba_obj)
        elif 'model' in line.lower():
           
            tempLine = line.split(':')
            modelTemp = tempLine[1].strip()
            modelObj.set_name(modelTemp)
        elif 'physical location' in line.lower():
            tempLine = line.split(':')
            locationTemp = tempLine[1].replace(' ','').replace('.','')
            modelObj.set_location(locationTemp.lower())
            for obj in hbaObjList:
                if obj.get_location() == modelObj.get_location():
                    obj.set_model(modelObj.get_name())
                    break
    return hbaObjList
        


class Hba_Entity:
    __hba_instance = 'NA'
    __hba_model = 'NA'
    __hba_wwn = 'NA'
    __hba_status  = 'NA'
    __hba_location = 'NA'
    
    def get_instance(self):
        return self.__hba_instance
    def get_model(self):
        return self.__hba_model 
    def get_wwn(self):
        return self.__hba_wwn 
    def get_status(self):
        return self.__hba_status
    def get_location(self):
        return self.__hba_location
    def set_instance(self,ins):
        self.__hba_instance = ins
    def set_model(self,model):
        self.__hba_model = model
    def set_wwn(self,wwn):
        self.__hba_wwn  = wwn
    def set_status(self,status):
        self.__hba_status =status
    def set_location(self,location):
        self.__hba_location = location

class Model_Entity:
    __model_name = 'NA'
    __model_location = 'NA'
    def get_name(self):
        return self.__model_name
    def get_location(self):
        return self.__model_location
    def set_name(self,name):
        self.__model_name = name
    def set_location(self,location):
        self.__model_location = location

    
def get_value_bykey(tempList,key):
    if key == key_lst[0]:
        return get_hba_instance(tempList)
    elif key == key_lst[1]:
        return get_hba_model(tempList)
    elif key == key_lst[2]:
        return get_hba_wwn(tempList)
    elif key == key_lst[3]:
        return get_hba_status(tempList)
    else:
        return "Key Error"
