# --*-- coding:utf-8 --*--
import sys 
import os
import re
from cmd import Cmd
reload(sys) 
sys.setdefaultencoding('utf-8')
path = os.path.dirname(os.path.abspath(__file__))
path = os.path.join(path, "..\\..\\..")
sys.path.append(path)
from common.contentParse import *

global key_lst  #对应Excel中属性列表
global attribute_arr #从传入的命令中获取的属性列表 
global  value_lst
global context

#对应excel中的属性字段
key_lst  = [
                     'device', 
                     'vendor',
                     'capacity',
                     'lunwwn',
                     'pv_name',
                     'vg_name'
            ]

#获取Linux主机集群 Server信息
def execute(context):
    #获取回文
    #start
    path = getValueFMap(context,style,'path')
    command = getValueFMap(context,style,'command').strip()
    attribute_arr = []
    value_lst = []
    if ';'== command[-1]:
        command =command[0:-1]
    addValueToMap(context,style,'command',command)
    #属性名与对应命令列表组成的字典
    attrcom_dic = get_attrcom_dic(context)
    #对应execel属性名
    json_attr_name = get_jsonarr_name(attrcom_dic)
    attr_valuelst_dic = get_attrvalue_dic(context,attrcom_dic)
    #获取attribute ,value_lst
    for key in key_lst:
        for attr in attr_valuelst_dic.keys():
            if key.lower().strip() in attr.lower():
                attribute_arr.append(attr)
    #检查key_lst
    check_keylst(key_lst,attribute_arr)
    
    device_value_lst = getValueFMap(attr_valuelst_dic, style, 'device')
    device_vendor_lst = getValueFMap(attr_valuelst_dic, style, 'vendor')
    device_lunwwn_lst = getValueFMap(attr_valuelst_dic, style, 'lunwwn')
    device_pv_lst = getValueFMap(attr_valuelst_dic, style, 'pv_name')
    device_vg_lst = getValueFMap(attr_valuelst_dic, style, 'vg_name')

    diskObjList = []
    #求device capacity
    diskObjList = get_device_cap_lst(device_value_lst)
    get_Vendor(device_vendor_lst,diskObjList)
    set_pvvgname(device_pv_lst,diskObjList)
    #检查pv_name
    #device 和 pvname 一样
    for disk in  diskObjList:
        if disk.get_device().lower().strip() == disk.get_pvname().lower().strip():
            pass
        else:
            disk.set_pvname('NA')
    #检查vg_name 
    #pv_name有值才有 vg_name
    for disk in diskObjList:
        if disk.get_pvname() != "NA":
            pass
        else:
            disk.set_vgname("NA")
    #求lun wwn
    lunwwn_lst = get_lunwwn_lst(attr_valuelst_dic['lunwwn'])
    #求lunwwn
    for disk in diskObjList:
        for lunobj in lunwwn_lst:
            disk_device = re.split('/',disk.get_device())[-1].strip()
            if lunobj.get_device() == disk_device:
                disk.set_wwn(lunobj.get_wwn())
                break
    #过滤，ls -al /dev/disk/by-id/，fdisk -l都有值才取    
    device_byid = []
    for line in device_lunwwn_lst:
        if '/' not in line:
            continue
        lst = line.split('/')
        dev = lst[-1].strip()
        if 'dm' not in dev:
            device_byid.append(dev)
    
    disk_obj_byid_lst = []
    for diskobj in diskObjList:
        device = diskobj.get_device()
        lst = device.strip().split('/')
        device = lst[-1].strip()
        if is_belong_lst(device,device_byid):
            disk_obj_byid_lst.append(diskobj)
    for diskobj in disk_obj_byid_lst:
        value_lst.append(diskobj.get_device())
        value_lst.append(diskobj.get_vendor())
        value_lst.append(diskobj.get_capacity())
        value_lst.append(diskobj.get_wwn())
        value_lst.append(diskobj.get_pvname())
        value_lst.append(diskobj.get_vgname())
    #获取json结果字符串                
    result = get_jsonstr(json_attr_name,attribute_arr, value_lst)
    addValueToMap(context,style,'result',result)
    return context

#检查key_lst
def check_keylst(key_lst,attribute_arr):
    if not (len(key_lst) == len(attribute_arr)):
        raise Exception("key lst Error")


#功能说明：返回属性名与对应回文组成的字典
def get_attrvalue_dic(context,attrcom_dic):
    all_comds_lst = get_purecommands_lst(attrcom_dic)
    path = getValueFMap(context,style,'path')
    all_comds_byfile = get_comdslst_byfile(all_comds_lst,path)
    
    return get_attrlst_dic(attrcom_dic,all_comds_byfile,path)

#功能说明：返回lun wwn
def get_lunwwn_lst(templst):
    lst = []
    for temp in templst:
        vlst = re.split('/',temp)
        if 'scsi'  in temp.lower():
            lst.append(temp)
        elif 'wwn'  in temp.lower():
            lst.append(temp)
        elif 'dm' in vlst[-1]:
            continue
    templst = lst
    wwn_obj_lst = []
    for line in templst:
        if ('/' in line) and (':' in line):
            lun_info = Lun_Info()
            devicename = re.split('/',line)[-1].strip()
            lun_info.set_device(devicename)
            wwn_lst = re.split('->',line)
            first = wwn_lst[0]
            wwn = ""
            if ('part' not in first.lower()):
                if ('scsi' in first.lower()):
                    wwn = re.split('-',first)[-1][1:].strip()
                elif ('wwn' in first.lower()):
                    wwn = re.split('-',first)[-1][2:].strip()
            elif ('part' in first.lower()):
                templst = re.split('-',first)
                if ('scsi' in first.lower()):
                    wwn = templst[-2][1:]+'-'+templst[-1]
                elif('wwn' in first.lower()):
                    wwn = templst[-2][2:].strip()+'-'+templst[-1]
            lun_info.set_wwn(wwn)
            wwn_obj_lst.append(lun_info)
    return wwn_obj_lst
             

#功能说明：返回Device
def get_device_cap_lst(tempList):
    diskobj_lst = []
    failStr = 'TOOLKIT_EXE_CMD_FAILED'
    
    if 0 == len(tempList):
        diskObj = Disk_Entity()
        diskobj_lst.append(diskObj)
        return diskobj_lst
    for line in tempList:
        if failStr.lower() in line.lower():
            diskObj = Disk_Entity()
            diskobj_lst.append(diskObj)
            return diskobj_lst
    #把每段device的回文放在一个列表中 
    obj_value_lst = []
    split_index_lst = []
    
    for i,line in enumerate(tempList):
        if ('disk' in line.lower()) and (',' in line.lower()):
            split_index_lst.append(i)
            
    len_indexlst = len(split_index_lst)
    for j in range(len_indexlst):
        lst = []
        start = split_index_lst[j]
        try:
            end = split_index_lst[j+1]
        except:
            end = len(tempList)
            
        lst = tempList[start:end]
        obj_value_lst.append(lst)
    #求diskobj_lst
    for lst in obj_value_lst:
        disk_obj = Disk_Entity()
        temp = ""
        fen_start = 0
        has_fenqu = False
        temp_diskobj_lst = []
        device = ""
        units = 0
        fen_units = 0
        
        for i,line in enumerate(lst):
            if ('disk' in line.lower()) and (',' in line):
                temp = line.lower()
                fen_start = i + 1
            device = temp.split(':')[0].replace('disk','').strip()
            cap = temp.split(':')[1].split(',')[0].strip()
            start = 0 
            end = 0
            if 'gb' in cap:
                cap = cap.replace('gb','').strip()
                cap = cap.strip()
            elif 'mb' in cap:
                cap = cap.replace('mb','').strip()
                cap = str(round(float(cap)/1024.0,2))
            disk_obj.set_device(device)
            disk_obj.set_capacity(cap+'GB')
            #求units
            for uline in lst:
                if ('units' in uline.lower()) and ('bytes' in uline.lower()):
                    temp = re.split('=',uline)[-1].strip()
                    temp = temp.replace('bytes', '')
                    temp = temp.strip()
                    units = int(temp)
                    disk_obj.set_unitbytes(units)
                    break
            
            #判断是否存在分区
            for f in lst[fen_start:]:
                if device.strip() in f:
                    has_fenqu = True
                    break
            temp_diskobj_lst.append(disk_obj)
            break
        #求分区信息
        if has_fenqu:
            for k,k_line in enumerate(lst[fen_start:]):
                if device in k_line:
                    fen_obj = Disk_Entity()
                    if '*' in k_line:
                        k_line = k_line.replace('*',' ')
                    namelst = re.split('\\s+',k_line.strip())
                    try:
                        name = namelst[0].strip()

                        start = int(namelst[1].strip())
                        end = int(namelst[2].strip())
                        fen_units = device.get_unitbytes()
                        
                    except:
                        pass
                    fen_obj.set_device(name)
                    
                    fen_obj.set_satrt(start)
                    fen_obj.set_end(end)
                    fen_obj.set_unitbytes(fen_units)
                    
                    #分区大小
                    fen_units =  disk_obj.get_unitbytes()
                    fen_start = fen_obj.get_start()
                    fen_end = fen_obj.get_end()
                    
                    fen_cap = round(((fen_end - fen_start)*fen_units)/1000.0/1000.0/1000.0,2)
                    fen_cap = str(fen_cap)+' GB'
                    fen_obj.set_capacity(fen_cap)
                    temp_diskobj_lst.append(fen_obj)
        #求diskobj_lst
        for temp_obj in temp_diskobj_lst:
            diskobj_lst.append(temp_obj)
    return diskobj_lst
    

#功能说明：返回厂商
def get_Vendor(tempList,diskList):
    failStr = 'TOOLKIT_EXE_CMD_FAILED'
    if 0 == len(tempList):
        return
    
    for line in tempList:
        if failStr.lower() in line.lower():
            return
    
    if len(tempList) > 3:
        tempList = tempList[2:-1]
        for diskObj in diskList:
            for line in tempList:
                lineArr = re.split('\\s+',line);
                if lineArr[-1] != '-' and diskObj.get_device() == lineArr[-1]:
                    diskObj.set_vendor(lineArr[2])
                    break

##功能说明：返回LUNWWN
def set_LUNWWN(tempList,diskList):
    failStr = 'TOOLKIT_EXE_CMD_FAILED'
    if 0 == len(tempList):
        return
    for line in tempList:
        if failStr.lower() in line.lower():
            return
        
    if len(tempList) > 3:
        tempList = tempList[2:-1]
        flag = False
        for line in tempList:
            if ('lun wwn' in line.lower()) and ('disk' in line.lower()):
                tempList = tempList[2:-1]
                break
        
        for diskObj in diskList:
            for line in tempList:
                tempArr = []
                tempArr = re.split('\\s+', line)
                if diskObj.get_device()[5:] == tempArr[1]:
                    diskObj.set_wwn(tempArr[3])
                    break
        
#功能说明：设置PV name 
def set_pvvgname(tempList,diskList):
    #{pv_name:'',vg_name:''}
    failStr = 'TOOLKIT_EXE_CMD_FAILED'
    if 0 == len(tempList):
        return
    
    for line in tempList:
        if failStr.lower() in line.lower():
            return
    pv_map_lst =[]
    for diskObj in diskList:
        for line in tempList:
            if ('pv' in line.lower()) and('name' in line.lower()):
                pvname = line.split(' ')[-1].strip()
                diskObj.set_pvname(pvname)
            elif ('vg' in line.lower()) and('name' in line.lower()):
                vgname = line.split(' ')[-1].strip()
                diskObj.set_vgname(vgname)
    

class Disk_Entity:
    __disk_device = 'NA'
    __disk_vendor = 'NA'
    __disk_capacity = 'NA'
    __disk_wwn = 'NA'
    __disk_pvname = 'NA'
    __disk_vgname = 'NA'
    __unitbytes= 0
    __start =0
    __end =0
    
    def get_device(self):
        return self.__disk_device
    def get_vendor(self):
        return self.__disk_vendor
    def get_capacity(self):
        return self.__disk_capacity
    def get_wwn(self):
        return self.__disk_wwn
    def get_pvname(self):
        return self.__disk_pvname
    def get_vgname(self):
        return self.__disk_vgname
    def get_unitbytes(self):
        return self.__unitbytes
    def get_start(self):
        return self.__start
    def get_end(self):
        return self.__end
    def set_device(self,device):
        self.__disk_device = device
    def set_vendor(self,vendor):
        self.__disk_vendor = vendor
    def set_capacity(self,cap):
        self.__disk_capacity = cap
    def set_wwn(self,wwn):
        self.__disk_wwn = wwn
    def set_pvname(self,pvname):
        self.__disk_pvname = pvname
    def set_vgname(self,vgname):
        self.__disk_vgname = vgname
    def set_unitbytes(self,byte):
        self.__unitbytes = byte
    def set_satrt(self,start):
        self.__start = start
    def set_end(self,end):
        self.__end = end

class Lun_Info:
    __wwn = 'NA'
    __devicename = 'NA'
    def set_wwn(self,wwn):
        self.__wwn = wwn
    def set_device(self,name):
        self.__devicename = name
    def get_wwn(self):
        return self.__wwn
    def get_device(self):
        return self.__devicename
