# --*-- coding:utf-8 --*--
import sys 
import os
reload(sys) 
sys.setdefaultencoding('utf-8')
path = os.path.dirname(os.path.abspath(__file__))
path =os.path.join(path, "..\\..\\..")
sys.path.append(path)
from common.contentParse import * 

#获取主机架构
def execute(context):
    global fileList
    global commandList
    command = ""
    pathstr = ""
    tempMap = {}
    result = ""
    command = context.get("command")
    commandList = command.split(',')
    pathstr = context.get("path")
    fileList = getTxtReportList(pathstr)
    for i in range(len(commandList)):
        dict = getCommandStartEndIndex(commandList[i])
        startIndex = dict["start"]
        endIndex = dict["end"]
        tempMap[commandList[i]] = fileList[startIndex:endIndex + 1]
    result = extractInfo(tempMap)
    context["result"] = result
    return context


#处理关键信息列表提取字段
def extractInfo(tempMap):
    totalKernelTime = [0, 0]
    totalUserTime = [0, 0]
    allProcessTime = [0, 0]
    sysKernelTime = [0, 0]
    sysUserTime = [0, 0]
    allSysTime = [0, 0]
    for i in range(len(commandList)):
        tempList = tempMap.get(commandList[i])

        for k in range(1, len(tempList) - 1):
            if "WMIC.exe" not in tempList[k]:
                totalKernelTime[i] = totalKernelTime[i] + int(tempList[k].split()[len(tempList[k].split()) - 2])
                totalUserTime[i] = totalUserTime[i] + int(tempList[k].split()[len(tempList[k].split()) - 1])
                
            if "System" in tempList[k]:
                sysKernelTime[i] = sysKernelTime[i] + int(tempList[k].split()[len(tempList[k].split()) - 2])
                sysUserTime[i] = sysUserTime[i] + int(tempList[k].split()[len(tempList[k].split()) - 1])
                
        allProcessTime[i] = totalKernelTime[i] + totalUserTime[i]
        allSysTime[i] = sysKernelTime[i] + sysUserTime[i]
    
    busyTime = allProcessTime[1] - allProcessTime[0]
    idleTime = allSysTime[1] - allSysTime[0]
    cpuRatio = 100 * (busyTime) / (busyTime + idleTime) / 2
    return str(cpuRatio) + "%"   
