# --*-- coding:utf-8 --*--
import sys 
import os
import re
from cmd import Cmd
reload(sys) 
sys.setdefaultencoding('utf-8')
path = os.path.dirname(os.path.abspath(__file__))
path = os.path.join(path, "..\\..\\..")
sys.path.append(path)
from common.contentParse import *

global key_lst  #对应Excel中属性列表
global attribute_arr #从传入的命令中获取的属性列表 
global  value_lst
global context

#对应excel中的属性字段
key_lst  = [
                'mapping_view_id','mapping_view_name','lun_group_id','lun_group_name','lun_id','lun_name','capacity','host_id','hostgroup_id','status','lun_wwn','lun_type'           
            ]

#获取Linux主机集群 Server信息
def execute(context):
    #获取回文
    #start
    path = getValueFMap(context,style,'path')
    command = getValueFMap(context,style,'command').strip()
    attribute_arr = []
    value_lst = []
    
    addValueToMap(context,style,'command',command)
    attrcom_dic = get_attrcom_dicv2(context)
    #对应execel属性名
    json_attr_name = get_jsonarr_name(attrcom_dic)
    attr_valuelst_dic = get_attrvalue_dic(context,attrcom_dic)
    #获取attribute ,value_lst
    #获取json结果字符串          
    
    lunobj_list = get_vvdetail_set(attr_valuelst_dic)      
    lunobj_list = get_vvset_info(lunobj_list,attr_valuelst_dic)
    lunobj_list = get_vlun_info(lunobj_list,attr_valuelst_dic)
    
    for key in key_lst:
        for attr in attr_valuelst_dic.keys():
            if key.lower().strip() in attr.lower():
                attribute_arr.append(attr)
    
    lunobj = Lun_Entity()
    for lunobj in lunobj_list:
        value_lst.append('NA')
        value_lst.append('NA')
        value_lst.append(lunobj.get_groupid())
        value_lst.append(lunobj.get_groupname())
        value_lst.append(lunobj.get_id())
        value_lst.append(lunobj.get_name())
        value_lst.append(lunobj.get_capacity())
        value_lst.append(lunobj.get_hostid())
        value_lst.append(lunobj.get_hostgroupid())
        value_lst.append(lunobj.get_status())
        value_lst.append(lunobj.get_wwn())
        value_lst.append(lunobj.get_type())
    
    result = get_jsonstr(json_attr_name,attribute_arr, value_lst)
    addValueToMap(context,style,'result',result)
    return context



def get_vvdetail_set(txt):
    vvdetail_list = txt.get(key_lst[4])[3:-1]
    lun_obj_list = []
    for line in vvdetail_list:
        lunobj = Lun_Entity()
        vvdetail_temp = re.split('\\s+', line)
        if len(vvdetail_temp) == 6 :
            lunobj.set_id(vvdetail_temp[0])
            lunobj.set_name(vvdetail_temp[1])
            lunobj.set_status(vvdetail_temp[2])
            cap = str(round(float(vvdetail_temp[3])/1024.0,2))+'GB'
            lunobj.set_capacity(cap)
            lunobj.set_wwn(vvdetail_temp[4])
            lunobj.set_type(vvdetail_temp[5])
            lun_obj_list.append(lunobj)
            
    return lun_obj_list
        
def get_vvset_info(lunobj_list,txt):
    vv_list = txt.get(key_lst[3])[3:-1]
    lunset_name = 'NA'
    lunset_id = 'NA'
    for lunobj in lunobj_list:
        for line in vv_list:
            lunset_temp = re.split('\\s+', line)
            if len(lunset_temp) == 3:
                lunset_id = lunset_temp[0]
                lunset_name = lunset_temp[1]
                if lunobj.get_name() == lunset_temp[2]:
                    lunobj.set_groupid(lunset_id)
                    lunobj.set_groupname(lunset_name)
                    break
            else:
                if lunobj.get_name() == lunset_temp[0]:
                    lunobj.set_groupid(lunset_id)
                    lunobj.set_groupname(lunset_name)
                    break
    
    return lunobj_list

def get_vlun_info(lunobj_list,txt):
    vlun_list = txt.get(key_lst[2])[3:-1]
    templates_list = []
    line_flag = 0
    for i,line in enumerate(vlun_list):
        if 'vlun' in line.lower() and 'templates' in line.lower():
            line_flag = i
            break
    templates_list = vlun_list[line_flag+2:-2]
            
    hostobj_list = []
    for line in templates_list:
        hostobj = Host_Entity()
        temparr = re.split('\\s+', line)
        if 'set:' in temparr[1]:
            lunset = temparr[1].split(':')
            hostobj.set_vvset(lunset[1])
        else:
            hostobj.set_vvname(temparr[1])
        if 'set:' in temparr[3]:
            hostset = temparr[3].split(':')
            hostobj.set_hostset(hostset[1])
            hostobj_list.append(hostobj)
        else:
            hostobj.set_hostname(temparr[3])
            hostobj_list.append(hostobj)
            
    hostset_list = txt.get('status')[3:-1]
    host_list = txt.get('host_id')[3:-1]
    for hostobj in hostobj_list:
        if hostobj.get_hostname() == 'NA':
            for line in hostset_list:
                temparr = re.split('\\s+', line)
                if len(temparr) > 1 and hostobj.get_hostset() == temparr[1] :
                    hostobj.set_hostid(temparr[0])
                    break
        else:
            for line in host_list:
                hosttemparr = re.split('\\s+', line)
                if hostobj.get_hostname() == hosttemparr[1] :
                    hostobj.set_hostid(hosttemparr[0])
                    break
    
    for vvobj in lunobj_list:
        for hostobj in hostobj_list:
            if vvobj.get_groupname() != 'NA' :
                if vvobj.get_groupname() == hostobj.get_vvset():
                    if hostobj.get_hostname() != 'NA':
                        vvobj.set_hostid(hostobj.get_hostid())
                        break
                    else:
                        vvobj.set_hostgroupid(hostobj.get_hostid())
                        break
            else:
                if vvobj.get_name() == hostobj.get_vvname():
                    if hostobj.get_hostname() != 'NA':
                        vvobj.set_hostid(hostobj.get_hostid())
                        break
                    else:
                        vvobj.set_hostgroupid(hostobj.get_hostid())
                        break
    return lunobj_list

def get_attrvalue_dic(context,attrcom_dic):
    all_comds_lst = get_purecommands_lst(attrcom_dic)
    path = getValueFMap(context,style,'path')
    all_comds_byfile = get_comdslst_byfile(all_comds_lst,path)
    return get_attrlst_dic(attrcom_dic,all_comds_byfile,path)


def get_attrcom_dicv2(context):
    command = getValueFMap(context,style,'command')
    #去除最后面的';'
    if ';' == command.strip()[-1]:
        command = command[0:-1]
    attrcom_dic= {}
    try:
        for comd in command.split(';'):
            if comd.count(':')==1:
                lst = comd.split(':')
                key = lst[0].strip()
                if (1 < len(lst))and (',' in lst[1]):
                    addValueToMap(attrcom_dic, style, key, lst[1].strip().split(','))
                else:
                    addValueToMap(attrcom_dic, style, key, [lst[1].strip()])
            else:
                value_lst = comd.split(':')
                key = value_lst[0].strip()
                rep = key+':'
                value = comd.replace(rep,'')
                value = value.strip()
                addValueToMap(attrcom_dic, style, key,[value])
    except:
        raise Exception("Not Leagal ,this commands..")
    return attrcom_dic

class Host_Entity:
    __hostname = 'NA'
    __hostset = 'NA'
    __vvname = 'NA'
    __vvset = 'NA'
    __hostid = 'NA'
    #get 
    def get_hostname(self):
        return self.__hostname
    def get_hostset(self):
        return self.__hostset
    def get_vvname(self):
        return self.__vvname
    def get_vvset(self):
        return self.__vvset
    def get_hostid(self):
        return self.__hostid
    
    #set 
    def set_hostname(self,name):
        self.__hostname = name
    def set_hostset(self,hostset):
        self.__hostset = hostset
    def set_vvname(self,vvname):
        self.__vvname = vvname
    def set_vvset(self,vvset):
        self.__vvset = vvset
    def set_hostid(self,hostid):
        self.__hostid = hostid

        
class Lun_Entity:
    __lungroup_id = 'NA'
    __lungroup_name = 'NA'
    __lun_id = 'NA'
    __lun_name = 'NA'
    __capacity = 'NA'
    __host_id = 'NA'
    __host_groupid = 'NA'
    __status = 'NA'
    __lun_wwn = 'NA'
    __lun_type = 'NA'
    
    #set
    def set_groupid(self,groupid):
        self.__lungroup_id = groupid
    def set_groupname(self,groupname):
        self.__lungroup_name = groupname
    def set_id(self,id):
        self.__lun_id = id
    def set_name(self,name):
        self.__lun_name = name
    def set_capacity(self,cap):
        self.__capacity = cap
    def set_hostid(self,hostid):
        self.__host_id = hostid
    def set_hostgroupid(self,hostgroupid):
        self.__host_groupid = hostgroupid
    def set_status(self,sta):
        self.__status = sta
    def set_wwn(self,wwn):
        self.__lun_wwn = wwn
    def set_type(self,type):
        self.__lun_type = type
        
    #get
    def get_groupid(self):
        return self.__lungroup_id
    def get_groupname(self):
        return self.__lungroup_name
    def get_id(self):
        return self.__lun_id 
    def get_name(self):
        return self.__lun_name  
    def get_capacity(self):
        return self.__capacity
    def get_hostid(self):
        return self.__host_id
    def get_hostgroupid(self):
        return self.__host_groupid
    def get_status(self):
        return self.__status
    def get_wwn(self):
        return self.__lun_wwn
    def get_type(self):
        return self.__lun_type
    
