# -*- coding: UTF-8 -*-
import os
import sys
path = os.path.dirname(os.path.abspath(__file__))
path = os.path.join(path, "..\\..")
sys.path.append(path)
from common.contentParse import handel_cmd_display
cmd_list = ['system-get-version',
            'system-get-node-info-iter',
            'system-get-info']
RET_MAP = 'ret_map'
ERR_MSG = 'err_msg'
CMD_DISPLAY = 'cmd_display_'

def execute(context):
    cmd_display = context.get(RET_MAP)
    err_msg = ''
    for cmd in cmd_list:
        cmd_and_param = []
        cmd_and_param.append(cmd)
        result, error_msg = handel_cmd_display(context, cmd_and_param)
        cmd_display.put(CMD_DISPLAY + cmd, str(result))
        err_msg += error_msg
    cmd_display.put(ERR_MSG, err_msg)
    return cmd_display
