# -*- coding: UTF-8 -*-
# 获取netapp share权限信息
import os
import sys
CURRENT_PATH = os.path.dirname(os.path.abspath(__file__))
sys.path.append(CURRENT_PATH)
CURRENT_PATH = os.path.join(CURRENT_PATH, '..\\..')
sys.path.append(CURRENT_PATH)
from common.contentParse import get_xml_item
from common.contentParse import handel_cmd_display
cmd_list = ['cifs-share-acl-list-iter-start',
            'cifs-share-acl-list-iter-next',
            'export-rule-get-iter']
CMD_ERROR = '<RESULT_ERROR>'
LOGGER = 'Logger'
RET_MAP = 'ret_map'
TAG = 'tag'
RECORDS = 'records'
MAXIMUM = 'maximum'
ERR_MSG = 'err_msg'
CMD_DISPLAY = 'cmd_display_'
SPECIAL_CMD = 'cifs-share-acl-list-iter-next'

def execute(context):
    cmd_display = context.get(RET_MAP)
    logger = context.get(LOGGER)
    err_msg = ''
    for cmd in cmd_list:
        cmd_and_param = []
        cmd_and_param.append(cmd)
        if cmd == cmd_list[1] and CMD_ERROR not in result:
            try:
                tag = get_xml_item(result, TAG)
                records = get_xml_item(result, RECORDS)
                cmd_and_param.append(TAG)
                cmd_and_param.append(tag)
                cmd_and_param.append(MAXIMUM)
                cmd_and_param.append(records)
            except Exception, e:
                logger.error(str(e))
        result, error_msg = handel_cmd_display(context, cmd_and_param)
        cmd_display.put(CMD_DISPLAY + cmd, result)
        err_msg += error_msg
    cmd_display.put(ERR_MSG, err_msg)
    return cmd_display
