# --*-- coding:utf-8 --*--
import sys
import os
reload(sys)
path = os.path.dirname(os.path.abspath(__file__))
path = os.path.join(path, '..\\..\\..')
sys.path.append(path)
from common.contentParse import is_success
from common.contentParse import handel_xml_info
from common.contentParse import get_jsonstr
from common.contentParse import addValueToMap
from common.contentParse import style
from common.contentParse import get_xml_lst
from common.contentParse import get_xml_item
from common.contentParse import handle_translation_char
global key_lst  #对应Excel中属性列表
global attribute_arr #从传入的命令中获取的属性列表
global context
#对应excel中的属性字段
key_lst = ['share-name',
           'mount-point',
           'description']

def execute(context):
    attr_valuelst_dic, json_attr_name, attribute_arr = handel_xml_info(context, key_lst)
    value_lst = []
    share_name = attr_valuelst_dic.get('share-name')
    if share_name and is_success(share_name):
        value_lst.extend(get_shareset_info(share_name))
    #获取json结果字符串
    result = get_jsonstr(json_attr_name, attribute_arr, value_lst)
    addValueToMap(context, style, 'result', result)
    return context

def get_shareset_info(share_name):
    #拼接列表，获取关键信息列表
    share_all = ''.join(share_name)
    cifs_share_info = get_xml_lst(share_all, 'cifs-share-info')
    #解析数据
    obj_lst = []
    for share_info_obj in cifs_share_info:
        share_name = handle_translation_char(get_xml_item(share_info_obj, 'share-name'))
        mount_point = get_xml_item(share_info_obj, 'mount-point')
        description = get_xml_item(share_info_obj, 'description')
        obj_lst.extend([share_name, mount_point, description])
    return obj_lst


