# --*-- coding:utf-8 --*--
import sys
import os
reload(sys)
path = os.path.dirname(os.path.abspath(__file__))
path = os.path.join(path, "..\\..\\..")
sys.path.append(path)
from common.contentParse import handel_xml_info
from common.contentParse import is_success
from common.contentParse import get_jsonstr
from common.contentParse import addValueToMap
from common.contentParse import style
from common.contentParse import get_xml_lst
from common.contentParse import get_xml_item
from common.contentParse import handle_translation_char
global key_lst  # 对应Excel中属性列表
global attribute_arr  # 从传入的命令中获取的属性列表
global value_lst
global context
# 对应excel中的属性字段
key_lst = [ 'pathname',
            'anon',
            'nosuid',
            'read-only',
            'read-write',
            'root',
            'set-flavor']

def execute(context):
    attr_valuelst_dic, json_attr_name, attribute_arr = handel_xml_info(context, key_lst)
    value_lst = []
    pathname = attr_valuelst_dic.get('pathname')
    if pathname and is_success(pathname):
        value_lst.extend(get_shareset_info(pathname))
    # 获取json结果字符串
    result = get_jsonstr(json_attr_name, attribute_arr, value_lst)
    addValueToMap(context, style, 'result', result)
    return context

def get_shareset_info(setinfo):
    share_all = ''.join(setinfo)
    cifs_shares = get_xml_lst(share_all, 'exports-rule-info-2')
    obj_lst = []
    for share_info_obj in cifs_shares:
        pathname = handle_translation_char(get_xml_item(share_info_obj, 'pathname'))
        security_rule_info = get_xml_lst(share_info_obj, 'security-rule-info')
        for sri in security_rule_info:
            anon = get_xml_item(sri, 'anon')
            nosuid = get_xml_item(sri, 'nosuid')
            read_only = get_xml_string(sri, 'read-only', 'name')
            read_write = get_xml_string(sri, 'read-write', 'all-hosts')
            root = get_xml_string(sri, 'root', 'name')
            set_flavor = get_xml_string(sri, 'sec-flavor', 'flavor')
            obj_lst.extend([pathname, anon, nosuid, read_only, read_write, root, set_flavor])
    return obj_lst

def get_xml_string(xml_string, out_tag, in_tag):
    xml_lst = get_xml_lst(xml_string, out_tag)
    return_xml = ''
    if len(xml_lst) > 0:
        for xml_item in get_xml_lst(xml_lst[0], in_tag):
            return_xml += get_xml_item(xml_item, in_tag) + ';'
    return return_xml
