# --*-- coding:utf-8 --*--
import sys
import os
reload(sys)
path = os.path.dirname(os.path.abspath(__file__))
path = os.path.join(path, "..\\..\\..")
sys.path.append(path)
from common.contentParse import handel_xml_info
from common.contentParse import is_success
from common.contentParse import get_jsonstr
from common.contentParse import addValueToMap
from common.contentParse import style
from common.contentParse import get_xml_lst
from common.contentParse import get_xml_item
from common.contentParse import handle_translation_char
global key_lst  # 对应Excel中属性列表
global attribute_arr  # 从传入的命令中获取的属性列表
global value_lst
global context
# 对应excel中的属性字段
key_lst = ['volume',
           'qtree',
           'id',
           'oplocks',
           'security-style',
           'status',
           'owning-vfiler']

def execute(context):
    attr_valuelst_dic, json_attr_name, attribute_arr = handel_xml_info(context, key_lst)
    value_lst = []
    volume = attr_valuelst_dic.get('volume')
    if volume and is_success(volume):
        value_lst.extend(get_set_info(volume))
    # 获取json结果字符串
    result = get_jsonstr(json_attr_name, attribute_arr, value_lst)
    addValueToMap(context, style, 'result', result)
    return context

def get_set_info(set_msg):
    set_msg_all = ''.join(set_msg)
    qtree_info = get_xml_lst(set_msg_all, 'qtree-info')
    obj_lst = []
    for info_obj in qtree_info:
        volume = get_xml_item(info_obj, 'volume')
        qtree = handle_translation_char(get_xml_item(info_obj, 'qtree'))
        id = get_xml_item(info_obj, 'id')
        oplocks = get_xml_item(info_obj, 'oplocks')
        security_style = get_xml_item(info_obj, 'security-style')
        status = get_xml_item(info_obj, 'status')
        owning_vfiler = get_xml_item(info_obj, 'owning-vfiler')
        obj_lst.extend([volume, qtree, id, oplocks, security_style, status, owning_vfiler])
    return obj_lst
