# --*-- coding:utf-8 --*--
import sys
import os
reload(sys)
path = os.path.dirname(os.path.abspath(__file__))
path = os.path.join(path, "..\\..\\..")
sys.path.append(path)
from common.contentParse import handel_xml_info
from common.contentParse import is_success
from common.contentParse import get_jsonstr
from common.contentParse import addValueToMap
from common.contentParse import style
from common.contentParse import get_xml_lst
from common.contentParse import get_xml_item
from common.contentParse import handle_translation_char
global key_lst  # 对应Excel中属性列表
global attribute_arr  # 从传入的命令中获取的属性列表
global value_lst
global context
# 对应excel中的属性字段
key_lst = ['vserver',
            'volume',
            'path',
            'share-name',
            'comment',
            'cifs-server',
            'max-connections-per-share',
            'offline-files-mode',
            'share-properties',
            'symlink-properties',
            'vscan-fileop-profile',
            'acl',
            'attribute-cache-ttl',
            'dir-umask',
            'file-umask',
            'force-group-for-create']

def execute(context):
    attr_valuelst_dic, json_attr_name, attribute_arr = handel_xml_info(context, key_lst)
    value_lst = []
    vserver = attr_valuelst_dic.get('vserver')
    if vserver and is_success(vserver):
        value_lst.extend(get_shareset_info(vserver))
    # 获取json结果字符串
    result = get_jsonstr(json_attr_name, attribute_arr, value_lst)
    addValueToMap(context, style, 'result', result)
    return context

def get_shareset_info(vserver):
    vserver_all = ''.join(vserver)
    cifs_shares = get_xml_lst(vserver_all, 'cifs-share')
    obj_lst = []
    for share_info_obj in cifs_shares:
        vserver = get_xml_item(share_info_obj, 'vserver')
        volume = get_xml_item(share_info_obj, 'volume')
        path = get_xml_item(share_info_obj, 'path')
        share_name = handle_translation_char(get_xml_item(share_info_obj, 'share-name'))
        comment = get_xml_item(share_info_obj, 'comment')
        cifs_server = get_xml_item(share_info_obj, 'cifs-server')
        max_connections_per_share = get_xml_item(share_info_obj, 'max-connections-per-share')
        offline_files_mode = get_xml_item(share_info_obj, 'offline-files-mode')
        share_properties = ''
        for csp in get_xml_lst(share_info_obj, 'cifs-share-properties'):
            share_properties += get_xml_item(csp, 'cifs-share-properties') + ';'
        symlink_properties = ''
        for sp in get_xml_lst(share_info_obj, 'symlink-properties'):
            symlink_properties += get_xml_item(sp, 'cifs-share-symlink-properties') + ';'
        vscan_fileop_profile = get_xml_item(share_info_obj, 'vscan-fileop-profile')
        acl = ''
        for _acl in get_xml_lst(share_info_obj, 'acl'):
            acl += get_xml_item(_acl, 'string') + ';'
        attribute_cache_ttl = get_xml_item(share_info_obj, 'attribute-cache-ttl')
        dir_umask = get_xml_item(share_info_obj, 'dir-umask')
        file_umask = get_xml_item(share_info_obj, 'file-umask')
        force_group_for_create = get_xml_item(share_info_obj, 'force-group-for-create')
        obj_lst.extend([vserver, volume, path, share_name, comment, cifs_server, max_connections_per_share,
                        offline_files_mode, share_properties, symlink_properties, vscan_fileop_profile,
                        acl, attribute_cache_ttl, dir_umask, file_umask, force_group_for_create])
    return obj_lst
