# --*-- coding:utf-8 --*--
import sys
import os
reload(sys)
path = os.path.dirname(os.path.abspath(__file__))
path = os.path.join(path, "..\\..\\..")
sys.path.append(path)
from common.contentParse import handel_xml_info
from common.contentParse import is_success
from common.contentParse import get_jsonstr
from common.contentParse import addValueToMap
from common.contentParse import style
from common.contentParse import get_xml_lst
from common.contentParse import get_xml_item
global key_lst  # 对应Excel中属性列表
global attribute_arr  # 从传入的命令中获取的属性列表
global value_lst
global context
# 对应excel中的属性字段
key_lst = [ 'owning-vserver-name',
            'name',
            'policy']

def execute(context):
    attr_valuelst_dic, json_attr_name, attribute_arr = handel_xml_info(context, key_lst)
    value_lst = []
    owning_vserver_name = attr_valuelst_dic.get('owning-vserver-name')
    if owning_vserver_name and is_success(owning_vserver_name):
        value_lst.extend(get_set_info(owning_vserver_name))
    # 获取json结果字符串
    result = get_jsonstr(json_attr_name, attribute_arr, value_lst)
    addValueToMap(context, style, 'result', result)
    return context

def get_set_info(set_msg):
    set_msg_all = "".join(set_msg)
    volume_attributes = get_xml_lst(set_msg_all, 'volume-attributes')
    obj_lst = []
    for info_obj in volume_attributes:
        owning_vserver_name = get_xml_item(info_obj, 'owning-vserver-name')
        name = get_xml_item(info_obj, 'name')
        policy = get_xml_item(info_obj, 'policy')
        obj_lst.extend([owning_vserver_name, name, policy])
    return obj_lst
