# --*-- coding:utf-8 --*--
import sys
import os
reload(sys)
sys.setdefaultencoding('utf-8')
path = os.path.dirname(os.path.abspath(__file__))
path = os.path.join(path, "..\\..\\..")
sys.path.append(path)
from common.contentParse import handel_xml_info
from common.contentParse import is_success
from common.contentParse import get_jsonstr
from common.contentParse import addValueToMap
from common.contentParse import style
from common.contentParse import get_xml_lst
from common.contentParse import get_xml_item
from common.contentParse import handle_translation_char
global key_lst  #对应Excel中属性列表
global attribute_arr #从传入的命令中获取的属性列表
global value_lst
global context
#对应excel中的属性字段
key_lst = [ 'export-policy',
            'id',
            'is-export-policy-inherited',
            'oplocks',
            'qtree',
            'security-style',
            'status',
            'volume',
            'vserver',
            'mode']

def execute(context):
    attr_valuelst_dic, json_attr_name, attribute_arr = handel_xml_info(context, key_lst)
    value_lst = []
    export_policy = attr_valuelst_dic.get('export-policy')
    if export_policy and is_success(export_policy):
        value_lst.extend(get_set_info(export_policy))
    #获取json结果字符串
    result = get_jsonstr(json_attr_name, attribute_arr, value_lst)
    addValueToMap(context, style, 'result', result)
    return context

def get_set_info(set_msg):
    set_msg_all = ''.join(set_msg)
    print(set_msg_all)
    quota_info = get_xml_lst(set_msg_all, 'qtree-info')
    obj_lst = []
    for info_obj in quota_info:
        export_policy = get_xml_item(info_obj, 'export-policy')
        id = get_xml_item(info_obj, 'id')
        is_export_policy_inherited = get_xml_item(info_obj, 'is-export-policy-inherited')
        oplocks = get_xml_item(info_obj, 'oplocks')
        qtree = handle_translation_char(get_xml_item(info_obj, 'qtree'))
        security_style = get_xml_item(info_obj, 'security-style')
        status = get_xml_item(info_obj, 'status')
        volume = get_xml_item(info_obj, 'volume')
        vserver = get_xml_item(info_obj, 'vserver')
        mode = get_xml_item(info_obj, 'mode')
        obj_lst.extend([export_policy, id, is_export_policy_inherited, oplocks,
                       qtree, security_style, status, volume, vserver, mode])
    return obj_lst
