#!/bin/sh
root_discovery_flowobj_id="discovery"
discovery_discovery_devInfo_innerflowobj_id="devInfo"
discovery_devInfo_id3_operationobj_cmd="machinfo|egrep 'Release|release  '"
discovery_devInfo_id4_operationobj_cmd="uname -a"
discovery_devInfo_id5_operationobj_cmd="cat /etc/issue"
discovery_devInfo_id6_operationobj_cmd="machinfo|egrep 'Version|version  '"
discovery_devInfo_id7_operationobj_cmd="netstat -nr |grep '[0-9]'|grep -v '127.0.0.1' |head -n 1 |awk '{print #1}'"
discovery_id7_id8_outputobj_name="IP"
discovery_id7_id8_outputobj_value="#1"
discovery_id7_outputitems="id8"
discovery_devInfo_id9_operationobj_params="IP"
discovery_devInfo_id9_operationobj_loopcmd="netstat -in|grep %s |awk '{print #1}'"
discovery_id9_id10_outputobj_name="En_num"
discovery_id9_id10_outputobj_value="#1"
discovery_id9_outputitems="id10"
discovery_devInfo_id11_operationobj_params="En_num"
discovery_devInfo_id11_operationobj_loopcmd="lanscan|grep %s"
discovery_devInfo_operationitems="id3#id4#id5#id6#id7#id9#id11"
discovery_discovery_innerflowitems="devInfo"
root_wwn_flowobj_id="wwn"
wwn_id13_id14_operationobj_cmd="iscsiutil -l"
wwn_id13_id15_operationobj_cmd="ioscan -funC fc"
wwn_id13_id16_operationobj_cmd="ioscan -funC fc | awk 'BEGIN{a=1}{if (a==0){print #NF;a=1;}}/fc.\*Fibre Channel/{a=0}'"
wwn_id16_id17_outputobj_name="fcDisks"
wwn_id16_id17_outputobj_value="#1"
wwn_id16_outputitems="id17"
wwn_id13_id18_operationobj_params="fcDisks"
wwn_id13_id18_operationobj_loopcmd="scsimgr get_info -D %s"
wwn_id13_operationitems="id14#id15#id16#id18"
wwn_wwn_innerflowitems="id13"
root_basic_flowobj_id="basic"
basic_id20_id21_operationobj_cmd="machinfo"
basic_id20_id22_operationobj_cmd="date"
basic_id20_id23_operationobj_cmd="netstat -in"
basic_id20_id24_operationobj_cmd="getconf KERNEL_BITS"
basic_id20_operationitems="id21#id22#id23#id24"
basic_basic_innerflowitems="id20"
root_hbaCardInfo_flowobj_id="hbaCardInfo"
hbaCardInfo_hbaCardInfo_getBaseInfo_innerflowobj_id="getBaseInfo"
hbaCardInfo_getBaseInfo_id27_operationobj_cmd="ioscan -funC fc"
hbaCardInfo_getBaseInfo_id28_operationobj_cmd="ioscan -funC fc|grep dev|awk '{print #1}'"
hbaCardInfo_id28_id29_outputobj_name="FCDiskValue"
hbaCardInfo_id28_id29_outputobj_value="#1"
hbaCardInfo_id28_outputitems="id29"
hbaCardInfo_getBaseInfo_id30_operationobj_params="FCDiskValue"
hbaCardInfo_getBaseInfo_id30_operationobj_loopcmd="fcmsutil %s"
hbaCardInfo_getBaseInfo_id31_operationobj_params="FCDiskValue"
hbaCardInfo_getBaseInfo_id31_operationobj_loopcmd="fcmsutil %s vpd"
hbaCardInfo_getBaseInfo_id32_operationobj_params="FCDiskValue"
hbaCardInfo_getBaseInfo_id32_operationobj_loopcmd="fcmsutil %s vpd |grep -E 'Part number|ROM Firmware version'"
hbaCardInfo_getBaseInfo_id33_operationobj_params="FCDiskValue"
hbaCardInfo_getBaseInfo_id33_operationobj_loopcmd="fcmsutil %s |grep -E 'Driver Version|Driver state'"
hbaCardInfo_getBaseInfo_operationitems="id27#id28#id30#id31#id32#id33"
hbaCardInfo_hbaCardInfo_HBACardTimeoutOldVer_innerflowobj_id="HBACardTimeoutOldVer"
hbaCardInfo_HBACardTimeoutOldVer_id35_operationobj_cmd="ioscan -fnC fc"
hbaCardInfo_HBACardTimeoutOldVer_id36_operationobj_cmd="ioscan -funC disk"
hbaCardInfo_HBACardTimeoutOldVer_id37_operationobj_cmd="vgdisplay -v | grep 'PV Name'"
hbaCardInfo_HBACardTimeoutOldVer_id38_operationobj_cmd="vgdisplay -v | grep 'PV Name' |awk '{print #3}'"
hbaCardInfo_id38_id39_outputobj_name="VgDisk"
hbaCardInfo_id38_id39_outputobj_value="#1"
hbaCardInfo_id38_outputitems="id39"
hbaCardInfo_HBACardTimeoutOldVer_id40_operationobj_params="VgDisk"
hbaCardInfo_HBACardTimeoutOldVer_id40_operationobj_loopcmd="pvdisplay %s'"
hbaCardInfo_HBACardTimeoutOldVer_operationitems="id35#id36#id37#id38#id40"
hbaCardInfo_hbaCardInfo_HBACardTimeoutNewVer_innerflowobj_id="HBACardTimeoutNewVer"
hbaCardInfo_HBACardTimeoutNewVer_id42_operationobj_cmd="ioscan -P health -C disk"
hbaCardInfo_HBACardTimeoutNewVer_id43_operationobj_cmd="ioscan -P health -C disk |grep online |awk '{print #3}''"
hbaCardInfo_id43_id44_outputobj_name="HWPath"
hbaCardInfo_id43_id44_outputobj_value="#1"
hbaCardInfo_id43_outputitems="id44"
hbaCardInfo_HBACardTimeoutNewVer_id45_operationobj_params="HWPath"
hbaCardInfo_HBACardTimeoutNewVer_id45_operationobj_loopcmd="scsimgr lun_map -H %s | grep 'SCSI transport protocol'"
hbaCardInfo_HBACardTimeoutNewVer_id46_operationobj_params="HWPath"
hbaCardInfo_HBACardTimeoutNewVer_id46_operationobj_loopcmd="scsimgr get_attr -H %s -a path_fail_secs"
hbaCardInfo_HBACardTimeoutNewVer_operationitems="id42#id43#id45#id46"
hbaCardInfo_hbaCardInfo_innerflowitems="getBaseInfo#HBACardTimeoutOldVer#HBACardTimeoutNewVer"
root_multipathInfo_flowobj_id="multipathInfo"
multipathInfo_multipathInfo_multipathBaseInfo_innerflowobj_id="multipathBaseInfo"
multipathInfo_multipathBaseInfo_id49_operationobj_cmd="ioscan -funNC disk"
multipathInfo_multipathBaseInfo_id50_operationobj_cmd="scsimgr lun_map"
multipathInfo_multipathBaseInfo_id51_operationobj_cmd="ioscan -m dsf"
multipathInfo_multipathBaseInfo_id52_operationobj_cmd="scsimgr get_attr -a leg_mpath_enable"
multipathInfo_multipathBaseInfo_id53_operationobj_cmd="ioscan -funNC disk|grep 'disk '|awk '{print #2}'"
multipathInfo_id53_id54_outputobj_name="MultiPathId"
multipathInfo_id53_id54_outputobj_value="#1"
multipathInfo_id53_outputitems="id54"
multipathInfo_multipathBaseInfo_id55_operationobj_params="MultiPathId"
multipathInfo_multipathBaseInfo_id55_operationobj_loopcmd="scsimgr get_attr -a preferred_path -D /dev/rdisk/disk%s"
multipathInfo_multipathBaseInfo_operationitems="id49#id50#id51#id52#id53#id55"
multipathInfo_multipathInfo_innerflowitems="multipathBaseInfo"
root_multipathStatus_flowobj_id="multipathStatus"
multipathStatus_multipathStatus_hpv3multi_innerflowobj_id="hpv3multi"
multipathStatus_hpv3multi_id58_operationobj_cmd="ioscan -P health | grep lunpath"
multipathStatus_hpv3multi_id59_operationobj_cmd="ioscan -funNC disk | awk 'BEGIN{a=1}{if (a==0){print #NF;a=1;}}/CLAIMED.\*HUAWEI/{a=0}'"
multipathStatus_id59_id60_outputobj_name="DiskID"
multipathStatus_id59_id60_outputobj_value="#1"
multipathStatus_id59_outputitems="id60"
multipathStatus_hpv3multi_id61_operationobj_params="DiskID"
multipathStatus_hpv3multi_id61_operationobj_loopcmd="scsimgr lun_map -D %s"
multipathStatus_hpv3multi_operationitems="id58#id59#id61"
multipathStatus_multipathStatus_deviceDetailInfo_innerflowobj_id="deviceDetailInfo"
multipathStatus_deviceDetailInfo_id63_operationobj_cmd="ioscan -funC fc|grep dev|awk '{print #1}'"
multipathStatus_id63_id64_outputobj_name="DevList"
multipathStatus_id63_id64_outputobj_value="#1"
multipathStatus_id63_outputitems="id64"
multipathStatus_deviceDetailInfo_id65_operationobj_params="DevList"
multipathStatus_deviceDetailInfo_id65_operationobj_loopcmd="fcmsutil %s"
multipathStatus_deviceDetailInfo_operationitems="id63#id65"
multipathStatus_multipathStatus_innerflowitems="hpv3multi#deviceDetailInfo"
root_aluaConfigure_flowobj_id="aluaConfigure"
aluaConfigure_aluaConfigure_deviceDetailInfo_innerflowobj_id="deviceDetailInfo"
aluaConfigure_deviceDetailInfo_id68_operationobj_cmd="ioscan -kfNnC disk"
aluaConfigure_deviceDetailInfo_id69_operationobj_cmd="ioscan -kfNnC disk |grep 'HUAWEI' |awk '{print #2}'"
aluaConfigure_id69_id70_outputobj_name="DiskLetter"
aluaConfigure_id69_id70_outputobj_value="#1"
aluaConfigure_id69_outputitems="id70"
aluaConfigure_deviceDetailInfo_id71_operationobj_params="DiskLetter"
aluaConfigure_deviceDetailInfo_id71_operationobj_loopcmd="scsimgr lun_map -D /dev/rdisk/disk%s"
aluaConfigure_deviceDetailInfo_operationitems="id68#id69#id71"
aluaConfigure_aluaConfigure_innerflowitems="deviceDetailInfo"
root_flowitems="discovery#wwn#basic#hbaCardInfo#multipathInfo#multipathStatus#aluaConfigure"
