﻿#coding:utf-8

#Command default time out, 2 minutes.
HOST_CMD_TIMEOUT = 5 * 60
HOST_CMD_SHORT_TIMEOUT = 2 * 60
LINUX_UPSCAN_CMD_TIMEOUT = 10 * 60

TEN = 10
NINE = 9
EGIHT = 8
SEVEN = 7
SIX = 6
FIVE = 5
FOUR = 4
THREE = 3
TWO = 2
ONE = 1
ZERO = 0
#进度常量start
PROG1 = 1
PROG5 = 5
PROG10 = 10
PROG15 = 15
PROG20 = 20
PROG25 = 25
PROG30 = 30
PROG35 = 35
PROG40 = 40
PROG45 = 45
PROG50 = 50
PROG55 = 55
PROG60 = 60
PROG65 = 65
PROG70 = 70
PROG75 = 75
PROG80 = 80
PROG85 = 85
PROG90 = 90
PROG95 = 95
PROG100 = 100
#进度常量end
LINUX_CMD_DFT_END_LIST = ['#', '$', '>']
#Constants for Linux OS.
QRY_ULTRAPATH_CMD = 'upadm show version'
QRY_MULTIPATHD_STATUS = 'service multipathd status | cat'
QRY_ARRAY_ID_CMD = 'upadm show array'
QRY_VLUN_ID_CMD = 'upadmin show vlun'
High_VER_QRY_VLUN_ID_CMD = 'upadmin show vlun type=all'
QRY_DEV_NAME_CMD = 'lsscsi |grep -Ei "huawei|huasy|symantec|hs|eisoo|udsafe|marstor|sanm|anystor|sugon|netposa|up"'
QRY_TGT_PORT_PATH_CMD = 'cat /sys/class/fc_transport/target%s/port_name'
QRY_DISK_PTH_MANAGED_BY_MULTIPATHD_CMD = 'multipath -ll|cat'
QRY_DISK_ISCSI_SESSION = "ll /sys/class/iscsi_session/"
QRY_DISK_ISCSI_PASH = "cat /sys/class/iscsi_session/%s/targetname"

#Linux ultrapath evaluation error message key.
ERR_MSG_KEY_QRY_MULTIPATH_FAILED = 'eval.host.multipath.reduntpath.qry.multipath.version.failed'
ERR_MSG_KEY_QRY_MULTIPATHD_FAILED = 'eval.host.multipath.reduntpath.qry.multipathd.srv.sta.failed'
ERR_MSG_KEY_QRY_MULTIPATHD_NO_PRIVILEGE = 'eval.host.multipath.reduntpath.qry.multipathd.no.privilege'
ERR_MSG_KEY_ULTRAPATH_MULTIPATHD_ALL_RUNNING = 'ultrapath.and.multipathd.all.running'
ERR_MSG_KEY_ULTRAPATH_MULTIPATHD_ALL_NOT_RUNING = 'eval.host.multipath.reduntpath.self&buildin.allnotexist'
ERR_MSG_KEY_QRY_ARRAY_ID_FAILED = 'eval.host.multipath.reduntpath.qry.array.id.failed'
ERR_MSG_KEY_QRY_ARRAY_LUN_PATH_FAILED = 'eval.host.multipath.reduntpath.qry.array.lunpath.failed'
ERR_MSG_KEY_QRY_SINGLE_LUN_PATH_FAILED = 'eval.host.multipath.reduntpath.qry.single.lunpath.failed'
ERR_MSG_KEY_LUN_PATH_NOT_PASSWED = 'lunpath.evalute.not.passed'
ERR_MSG_KEY_QRY_ARRAY_ID_EMPTY = 'eval.host.multipath.reduntpath.qry.array.id.empty'

ERR_MSG_KEY_QRY_VLUN_ID_FAILED = 'eval.host.multipath.reduntpath.qry.vlun.id.failed'
ERR_MSG_KEY_QRY_VLUN_ID_EMPTY = 'eval.host.multipath.reduntpath.donot.get.disk.information'

OS_TYPE_WINDOWS = "Windows"
OS_TYPE_LINUX = "Linux"
OS_TYPE_SOLARIS = "Solaris"
OS_TYPE_AIX = "AIX"

OS_TYPE_LINUX_LOW = "linux"
OS_TYPE_AIX_LOW = "aix"
OS_TYPE_SOLARIS_LOW = "solaris"
OS_TYPE_SUNOS_LOW = "sunos"
OS_TYPE_VMWARE_LOW = "vmkernel"
OS_TYPE_VMWARE_OS_LOW = "vmware"
OS_TYPE_WINDOWS_LOW = "windows"
OS_TYPE_FUSIONSPHERE_LOW = "fusionsphere"

#buglist3
ERR_MSG_SOLARIS_REPORT_LUN_CHECK_UNABLE_EVAL = "solaris.report.lun.check.unable.eval"
ERR_MSG_SOLARIS_REPORT_LUN_CHECK_NOT_PASSED = "solaris.report.Lun.check.failed"
#buglist5
ERR_MSG_DIF_NOT_IDENTITY_UNABLE_EVAL = "dif.not.identity.check.unable.eval"
ERR_MSG_DIF_NOT_IDENTITY_NOT_PASSED = 'dif.not.identity.check.not.passed'
ERR_MSG_MULTIPATHD_NO_HW_DISK_FOUND = 'eval.host.multipath.reduntpath.no.hw.disk.managed.by.multipathd'

#Suggest message key.

SUGGEST_MSG_KEY_QRY_MULTIPATHD_USE_ROOT = 'qry.multipathd.use.root'

LINUX_LOWER_ULTRAPATH_VER = '5.01.017'
LINUX_MIDDLE_ULTRAPATH_VER = '8.01.051'
CTRL_ID_RE_PATTERN = '\d+[a-dA-D]'
CTRL_ID_NEW_RE_PATTERN = '\'\d*[a-dA-D]'
NEW_PATH_FOUND_PATTERN = 'controller.*\d+[a-dA-D].*path'
NEW_PATH_FOUND_NEW_PATTERN = 'controller.*\d*[a-dA-D].*path'
#Linux multipathd service.
TARGET_PORT_NUM_PATTERN = '\d+:\d+:\d+'
IP_BUSINESS_PATTERN = '\d+\.\d+\.\d+\.\d+'
NEW_HW_DISK_PATTERN = 'dm\-\d+\s+(huawei|huasy|symantec|hs|eisoo|udsafe|marstor|sanm|anystor|sugon|netposa)'
NEW_HW_DISK_PATTERN_UP = 'dm\-\d+\s+(up)'

ERR_MSG_KEY_QRY_TGT_PORT_NUM_FAILED = 'eval.host.multipath.reduntpath.qry.tgt.port.number.failed'
ERR_MSG_KEY_QRY_TGT_PORT_NUM_EMPTY = 'eval.host.multipath.reduntpath.donot.get.disk.information'
ERR_MSG_KEY_QRY_TGT_PORT_PATH_EMPTY = 'eval.host.multipath.reduntpath.qry.tgt.port.path.empty'


#vmware
CHECK_FAIL = 0
CHECK_PASS = 1
SOFT_WARE_VERSION = "software version"
ULTRAPATH_VERSION = "ultrapath for"
DRIVER_VERSION = "driver version"
MULTIPATH_PLUGIN = "multipath plugin"
VENDOR = "vendor"
MULTI_PATH_TYPE = "type"
NOT_PASS_VLUN_IDS = "failVluns"
NOT_PASS_DEVICE = 'failDevices'
ITEM_KEY = "multipath_check"
ULTR_LUN_COMMAND = "esxcli upadm show vlun"
ULTR_LUN_COMMAND_HIGH_VERSION = "esxcli upadm show vlun -t all"
NMP_DEVICE_COMMAND = "esxcfg-mpath -b | grep -E -i 'huawei|huasy|symantec|hs|eisoo|udsafe|marstor|sanm|anystor|sugon|netposa'"
HW_DISK_KEYWORD = 'huawei|huasy|symantec|hs|eisoo|udsafe|marstor|sanm|anystor|sugon|netposa'
#华为盘标识
HW_DISK_VENDOR = [
    'huawei',
    'huasy',
    'symantec',
    'hs',
    'eisoo',
    'udsafe',
    'marstor',
    'sanm',
    'anystor',
    'sugon',
    'netposa']
#show lun command
SHOW_LUN_COMMAND = "esxcli upadm show vlun -l "
#ultra path version
ULTRA_PATH_VERSION_COMMAND = "esxcli upadm show version"
#check nmp path exist command
NMP_EXIST_COMMAND = "esxcli storage core device list"
#os name command
OS_NAME_COMMAND = "uname -a"
#临界版本号
CMP_MULTI_PATH_VERSION = 801051
#自研多路径标识
ULTRA = 0
#自带多路径标识
NMP = 1
#自研自带共存
ULTRA_AND_NMP = 2
MAGIC_INT16 = 16
MAGIC_INT0 = 0
MAGIC_INT1 = 1
MAGIC_INT2 = 2
#结果标志
RESULT_FLAG = "root@~ #result\n"
#自研多路径评估不通过
ULTRA_NOT_PASS_TIPS = 'eval.host.multipath.reduntpath.ultrapath.donot.have.redundant.path'
ULTRA_HYPER_METRO_VLUN_NOT_PASS_TIPS = 'eval.host.mulitipath.hyper.lun.not.pass'
ULTRA_VLUN_NOT_PASS_TIPS = 'eval.host.mulitipath.normal.lun.and.hyper.lun.not.pass'

#自带多路径评估不通过
NMP_NOT_PASS_TIPS = 'eval.host.multipath.reduntpath.self.donot.have.redundant.path'
#操作系统在支持范围内
OS_NOT_SUPPORT_TIPS = 'eval.host.mulitipath.info.check.os.not.support.tips'
#评估不通过
NO_MULTIPATH_UNABLE_TIPS = 'eval.host.mulitipath.info.check.no.multipath.unable.eval.tips'
#无法评估
CHECK_UNABLE_TIPS = 'eval.host.mulitipath.info.check.unable.eval.tips'
#hp-ux所有在线wwpn查询失败，无法评估
CHECK_HPUX_ONLINE_WWPN_UNABLE_TIPS = 'eval.host.mulitipath.info.check.unable.eval.tips.wwpn'
#query all device fail
QUERY_ALL_DEVICE_FAIL_TIPS = "eval.host.multipath.info.check.all.device.query.fail.tips"
#query  device part fail
QUERY_PARAT_DEVICE_FAIL_TIPS = "eval.host.multipath.info.check.part.device.query.fail.tips"
#query all lun fail
QUERY_ALL_LUN_FAIL_TIPS = "eval.host.multipath.info.check.all.lun.query.fail.tips"
#query part lun fail,and normal lun not redundant.
QUERY_PART_LUN_FAIL_TIPS = "eval.host.multipath.info.check.part.lun.query.fail.tips"

QRY_FAIL_HYPER_LUN_NO_REDUNDANT="eval.host.multipath.info.check.part.lun.query.fail.hyper.lun.no.redundant.tips"
QRY_FAIL_NORMAL_AND_HYPER_LUN_NO_REDUNDANT="eval.host.multipath.info.check.part.lun.query.fail.normal.and.hyper.lun.no.redundant.tips"
RECOMMENDED_ACTIONS_NETWORK_CONNECTION = "eval.host.multipath.reduntpath.recommended.actions.network.connection"
RECOMMENDED_ACTIONS_SUPER_ADMIN = "eval.host.multipath.reduntpath.recommended.actions.super.admin"
#hpv1v2
EVAL_NOTPASS = "eval.host.multipath.hpv1v2.notpass.tips"

#无法评估
#ioscan -funC disk ，评估不通过：未查询到磁盘
EVAL_FAILED_FCDISK = "eval.host.multipath.reduntpath.recommended.actions.func.disk"
EVAL_FAILED_FCDISK_REASON = "eval.host.multipath.reduntpath.qry.func.disk.failed.hpuxv1v2"


#pvdisplay /dev/dsk/c22t0d3 | grep 'PV Name' ，评估不通过：未查询到物理卷冗余路径逻辑链路
EVAL_FAILED_PV = "eval.host.multipath.reduntpath.recommended.actions.pv.name"
EVAL_FAILED_PV_REASON = "eval.host.multipath.reduntpath.qry.pv.name.failed.hpuxv1v2"


#ioscan -funC fc ，评估不通过：未查询到HBA信息
EVAL_FAILED_FCNOT = "eval.host.multipath.reduntpath.recommended.actions.func.fc"
EVAL_FAILED_FCNOT_REASON = "eval.host.multipath.reduntpath.qry.func.fc.failed.hpuxv1v2"

#回显正常，但是无冗余路径，评估不通过。和此提示用于替换EVAL_NOTPASS
EVAL_RETOK_NOTPASS = "eval.host.multipath.reduntpath.self.donot.have.redundant.path"

DEV_LEVEL2_TYPE =  'deviceTypeLevel2'

