# --*-- coding:utf-8 --*--
import sys 
import os
import re
from cmd import Cmd
reload(sys) 
sys.setdefaultencoding('utf-8')
path = os.path.dirname(os.path.abspath(__file__))
path = os.path.join(path, "..\\..\\..")
sys.path.append(path)
from common.contentParse import *
from common.contentAnalyse import get_aixmulobj_lst

global key_lst  #对应Excel中属性列表
global attribute_arr #从传入的命令中获取的属性列表 
global  value_lst
global context

#对应excel中的属性字段
key_lst  = [
                     'multipath_name', 
                     'multipath_version',
                     'multipath_status'
            ]
Multipath_Name  = "Multipath"
UltraPath_Name  = "UltraPath"
PowerPath_Name  = "PowerPath"

#获取Linux主机集群 Server信息
def execute(context):
    #获取回文
    #start
    path = getValueFMap(context,style,'path')
    command = getValueFMap(context,style,'command').strip()
    attribute_arr = []
    value_lst = []
    if ';'== command[-1]:
        command =command[0:-1]
    addValueToMap(context,style,'command',command)
    #属性名与对应命令组成的列表的字典
    attrcom_dic = get_attrcom_dic(context)
    #对应execel属性名
    json_attr_name = get_jsonarr_name(attrcom_dic)
    attr_valuelst_dic = get_attrvalue_dic(context,attrcom_dic)
    #获取attribute ,value_lst
    for key in key_lst:
        for attr in attr_valuelst_dic.keys():
            if key.lower().strip() in attr.lower():
                attribute_arr.append(attr)
    #检查attribute
    if len(key_lst) == len(attribute_arr):
        pass
    else:
        raise Exception('key_lst not match.Please check it..')
    
    multipath_lst = getValueFMap(attr_valuelst_dic, style, attribute_arr[0])
    txtblock_lst = get_eachmulti_lst(multipath_lst)
    obj_lst = get_aixmulobj_lst(txtblock_lst)
    #求多路径状态
    status_lst = getValueFMap(attr_valuelst_dic, style, attribute_arr[2])
    statu_value_dic = get_status(status_lst)
    for mul in obj_lst:
        if mul.get_name().lower() ==  Multipath_Name.lower():
            mul.set_status(statu_value_dic[Multipath_Name])
            continue
        if mul.get_name().lower() ==  UltraPath_Name.lower():
            mul.set_status(statu_value_dic[UltraPath_Name])
            continue
        if mul.get_name().lower() == PowerPath_Name.lower():
            mul.set_status(statu_value_dic[PowerPath_Name])
    for multipathObj in obj_lst:
        value_lst.append(multipathObj.get_name())
        value_lst.append(multipathObj.get_version())
        value_lst.append(multipathObj.get_status())
    
    #获取json结果字符串                
    result = get_jsonstr(json_attr_name,attribute_arr, value_lst)
    addValueToMap(context,style,'result',result)
    return context

#功能说明：返回属性名和对应回文的字典
def get_attrvalue_dic(context,attrcom_dic):
    all_comds_lst = get_purecommands_lst(attrcom_dic)
    path = getValueFMap(context,style,'path')
    all_comds_byfile = get_comdslst_byfile(all_comds_lst,path)
    return get_attrlst_dic(attrcom_dic,all_comds_byfile,path)


#功能说明：返回单个命令的回文列表之列表
def get_eachmulti_lst(tempList):
    index = 0 
    txtList = []
    for i,line in enumerate(tempList):
        if divide in line:
            txtList.append(tempList[index:i+1])
            index = i+1 
    return txtList


def get_status(status_lst):
    multipath_flag = "cmd_display_multipath_multipath"
    ultrapath_flag = "cmd_display_multipath_status_phypath"
    powerment_flag = "cmd_display_multipath_powermt_display"
    sta_lst = []
    status_dic = {}
    status_dic[Multipath_Name] = 'NA'
    status_dic[UltraPath_Name] = 'NA'
    status_dic[PowerPath_Name] = 'NA'
    
    index = 0 
    for i,line in enumerate(status_lst):
        if divide in line.lower():
            sta_lst.append(status_lst[index:i+1])
            index = i+1
    try:
        for j,templst in enumerate(sta_lst):
            if is_belong_lst(multipath_flag,templst):
                status = '\\n'.join(templst[2:-1])
                status_dic[Multipath_Name] = status
                status_value_lst.append(status)
                continue
            
            if is_belong_lst(ultrapath_flag,templst):
                status = '\\n'.join(templst[2:-1])
                status_dic[UltraPath_Name] = status 
                continue 
            
            if is_belong_lst(powerment_flag,templst):
                status = '\\n'.join(templst[2:-1])
                status_dic[PowerPath_Name] = status 
    except:
        pass
    return status_dic
            

class Multipath_Entity:
    __mul_name = 'NA'
    __mul_version = 'NA'
    __mul_status = 'NA'
    
    def get_name(self):
        return self.__mul_name
    def get_version(self):
        return self.__mul_version
    def get_status(self):
        return self.__mul_status
    
    def set_name(self,name):
        self.__mul_name = name
    def set_version(self,version):
        self.__mul_version = version
    def set_status(self,status):
        self.__mul_status = status
