# --*-- coding:utf-8 --*--
import sys 
import os
import re
from cmd import Cmd
reload(sys) 
sys.setdefaultencoding('utf-8')
path = os.path.dirname(os.path.abspath(__file__))
path = os.path.join(path, "..\\..\\..")
sys.path.append(path)
from common.contentParse import *
from common.contentAnalyse import get_aixmulobj_lst

global key_lst  #对应Excel中属性列表
global attribute_arr #从传入的命令中获取的属性列表 
global  value_lst
global context

#对应excel中的属性字段
key_lst = ["server_model", "cpu_model", "memory", "os", "multipath", "cluster", "lvm/vxvm", "database"]

#获取Linux主机集群 Server信息
def execute(context):
    #获取回文
    #start
    path = getValueFMap(context, style, 'path')
    command = getValueFMap(context, style, 'command').strip()
    attribute_arr = []
    value_lst = []
        
    addValueToMap(context, style, 'command', command)
    #{属性名:[对应列表]}
    attrcom_dic = get_attrcom_dic(context)
    
    #对应execel属性名
    json_attr_name = get_jsonarr_name(attrcom_dic)
    
    #{属性名:[对应回文的列表]}
    attr_valuelst_dic = get_attrvalue_dic(context, attrcom_dic)
    #获取attribute ,value_lst
    
    for key in key_lst:
        tempList = []
        for attr in attr_valuelst_dic.keys():
            if key.lower().strip() in attr.lower():
                attribute_arr.append(attr)
                tempList = attr_valuelst_dic[attr]
                value = get_value_bykey(tempList, key)
                value_lst.append(value)


    #获取json结果字符串                
    result = get_jsonstr(json_attr_name, attribute_arr, value_lst)
    addValueToMap(context, style, 'result', result)
    return context


#return {属性名:[回文列表]}
def get_attrvalue_dic(context, attrcom_dic):
    all_comds_lst = get_purecommands_lst(attrcom_dic)
    path = getValueFMap(context, style, 'path')
    all_comds_byfile = get_comdslst_byfile(all_comds_lst, path)
    return get_attrlst_dic(attrcom_dic, all_comds_byfile, path)

#return [[单个命令的回文]..]
def get_block_lst(tempList):
    index = 0 
    txtList = []
    for i, line in enumerate(tempList):
        if divide in line:
            txtList.append(tempList[index:i + 1])
            index = i + 1 
    return txtList
 
#Server model
def get_servermodel(tempList):
    result = "Aix"
    return result

#CPU model    x86-64 AMD64
def get_cpumodel(tempList):
    cpu_model = ""
    if not is_success(tempList):
        return 'NA'
    tempList = tempList[2:-1]
    result = 'NA'
    result = parseRetWithSep(tempList, "System Model", ":")
    result2 = 'NA'
    result2 = parseRetWithSep(tempList, "Kernel Type", ":")
    cpu_model = result2 + " " + result
    cpu_model = cpu_model.replace(',', ' ')
    return cpu_model
    
    
#Memory
def get_memory(tempList):
    if not is_success(tempList):
        return 'NA'
    tempList = tempList[2:]
    
    for call in tempList :
        if 0 == len(call.strip()):
            continue
        if ":" in call:
            fieldArray = call.strip().split(":")
            if 2 > len(fieldArray) :
                continue
    
            if "Memory Size" == fieldArray[0].strip():
                return str(round(float(fieldArray[1].strip().split(" ")[0].strip()) / 1024, 2)) + " GB"
    return "NA"

#return :[[单个命令回文],...]
def get_eachmulti_lst(tempList):
    index = 0 
    txtList = []
    for i, line in enumerate(tempList):
        if divide in line:
            txtList.append(tempList[index:i + 1])
            index = i + 1 
    return txtList

#Multipath
def get_multipath(tempList):
    mulBlock_lst = get_eachmulti_lst(tempList)
    mulobj_lst = get_aixmulobj_lst(mulBlock_lst)
    multipaths = ""
    #name为NA则认为无该多路径软件
    objchecklst = []
    for mul in mulobj_lst:
        if mul.get_name() != 'NA':
            objchecklst.append(mul)
    if 0 == len(objchecklst):
        return "NA"
    
    for mul in objchecklst:
        multipaths = multipaths + mul.get_name() + ','
    multipaths = multipaths[0:-1]
    if "" == multipaths:
        multipaths = 'NA'
    return multipaths
    
    
#求集群名称
def get_clusternames(cluster_lst):
    cluster_block_lst = get_block_lst(cluster_lst)
    #PaceMaker lst
    pacemaker_lst = []
    for lst in cluster_block_lst:
        lst_temp = ';'.join(lst)
        #cmd_display_cluster_crmadmin, cmd_display_cluster_classes,cmd_display_cluster_crm_mon
        if ('cmd_display_cluster_crmadmin' in lst_temp) or ('cmd_display_cluster_classes' in lst_temp) or ('cmd_display_cluster_crm_mon' in lst_temp):
            pacemaker_lst.append(lst)
    #RHCS lst
    rhcs_lst = []
    for lst in cluster_block_lst:
        lst_temp = ';'.join(lst)
        #cmd_display_cluster_crmadmin, cmd_display_cluster_classes,cmd_display_cluster_crm_mon
        if ('cmd_display_cluster_RHCS' in lst_temp) or ('cmd_display_cluster_clustat' in lst_temp):
            rhcs_lst.append(lst)
    #VCS lst
    vcs_lst = []
    for lst in cluster_block_lst:
        lst_temp = ';'.join(lst)
        #cmd_display_cluster_crmadmin, cmd_display_cluster_classes,cmd_display_cluster_crm_mon
        if ('cmd_display_cluster_VRTSvcs' in lst_temp) or ('cmd_display_storage_foundation_hastatus_sum' in lst_temp):
            vcs_lst.append(lst)
    #RAC lst
    rac_lst = []
    rac_statuslst = []
    for lst in cluster_block_lst:
        lst_temp = ';'.join(lst)
        if ('cmd_display_cluster_findrac' in lst_temp.lower()):
            rac_lst.append(lst)
        if ('cmd_display_cluster_racstat' in lst_temp.lower()):
            rac_statuslst.append(lst)
            
    #HACMP lst
    #cmd_display_cluster_hacmp_status
    #cmd_info_cluster_defaulthacmp
    
    hacmp_lst = []
    lst = get_valuelst_bydesc(cluster_block_lst, "cmd_display_cluster_hacmp_status")
    lst2 = get_valuelst_bydesc(cluster_block_lst, "cmd_display_cluster_defaulthacmp")
    hacmp_lst.append(lst)
    hacmp_lst.append(lst2)
    
    #RAC obj 
    rac_obj = Cluster_Info()
    has_racone = False
    has_racsec = False
    has_rac = False
    if 0 != len(rac_lst):
        if (len(rac_lst[0]) > 2):
            rac_result_lst = rac_lst[0]
            for line in rac_result_lst[2:-1]:
                if ('crs_stat' in line):
                    has_racone = True
                    break
    if 0 != len(rac_statuslst):
        has_racsec = True
        
    #状态回文
    has_rac = has_racone and has_racsec
    if has_rac:
        rac_obj.set_name('RAC')

    #PaceMaker obj
    pacemaker_obj = Cluster_Info()
    has_pace = True
    if 0 == len(pacemaker_lst):
        has_pace = False
        
    for pacelst in pacemaker_lst:
        has_pace = is_success(pacelst)
        has_pace = has_pace & has_pace
        
    if has_pace:
        pacemaker_obj.set_name('NA')
               
    #RHCS obj
    rhcs_obj = Cluster_Info()
    has_rhcs = True 
    if 0 == len(rhcs_lst):
       has_rhcs = False
        
    for rhcslst in rhcs_lst:
        has_rhcs = is_success(rhcslst)
        has_rhcs = has_rhcs & has_rhcs
    if has_rhcs:
        rhcs_obj.set_name('NA')
    #VCS obj
    vcs_obj = Cluster_Info()
    has_vcs = True
    if 0 == len(vcs_lst):
        has_vcs = False
    for vcslst in vcs_lst:
        has_vcs = is_success(vcslst)
        has_vcs = has_vcs & has_vcs
    if has_vcs:
        vcs_obj.set_name('NA')
    #HACMP obj
    hacmp_obj = Cluster_Info()
    has_hacmp = False
    has_hacmp = has_cluster(hacmp_lst)
    if has_hacmp:
        state = ""
        statu_lst = get_valuelst_bydesc(hacmp_lst, "cmd_display_cluster_hacmp_status")
        
        if len(statu_lst[2:-1]) > 0:
            state = '\\n'.join(statu_lst[2:-1])
        else:
            state = 'NA'
        hacmp_obj.set_name('HACMP')
        hacmp_obj.set_status(state)

    #cluster obj 集合
    cluster_obj_lst = []
    if rac_obj.get_name() != 'NA':
        cluster_obj_lst.append(rac_obj)
    if pacemaker_obj.get_name() != 'NA':
        cluster_obj_lst.append(pacemaker_obj)
    if rhcs_obj.get_name() != 'NA':
        cluster_obj_lst.append(rhcs_obj)
    if vcs_obj.get_name() != 'NA':
        cluster_obj_lst.append(vcs_obj)
    if hacmp_obj.get_name() != 'NA':
        cluster_obj_lst.append(hacmp_obj)
    #集群名称
    cluster_value = ""
    for cluster in cluster_obj_lst:
        cluster_value = cluster_value + cluster.get_name() + ','
    cluster_value = cluster_value[0:-1]
    if "" == cluster_value.strip():
        return "NA"
    else:
        return cluster_value
    
#lvm/vxvm
def get_lvm(tempList):
    #cmd_display_logic_volune_lslpp_l_vxvm 成功为：VxVM
    result = "NA"
    if 0 == len(tempList):
        return 'NA'
    lvmblock = get_block_lst(tempList)
    for lst in lvmblock:
        if is_success(lst):
            result = 'VxVM'
    return result 

# database
def get_database(tempList):
    result = "NA"
    index = 0
    #回文失败
    if not is_success(tempList):
        return result
    for i in range(len(tempList)):
        if "Enterprise Edition" in tempList[i]:
            index = i
            break
    try:
        result = tempList[index]
    except:
        result = 'NA'
    
    if 0 == index:
        return "NA"
    return result 


#OS
def get_os(tempList):
   if 0 == len(tempList):
       return 'NA'
   else:
       result = '\\n'.join(tempList[1:-1])
   lastLine = ""
   callList = tempList[2:-1]
   for call in callList :
        if 0 == len(call.strip()):
            continue
        lastLine = call.strip();
   if 0 == len(lastLine) :
        return "NA"
   devArray = lastLine.split("-");
   if 3 > len(devArray):
        return "NA"
   result = "NA"
   try:
        result += "AIX " + str(float(devArray[0].strip()) / 1000)
        result += ",Technology level " + str(int(devArray[1].strip()))
        spVersion = int(devArray[2].strip())
        if 0 != spVersion:
            result += ",Service Pack " + str(spVersion)
   except :
        return "NA"
   result = result.replace(',',' ') 
   return result
   
   
     
def get_value_bykey(tempList, key):
    if key == key_lst[0]:
        return get_servermodel(tempList)
    elif key == key_lst[1]:
        return get_cpumodel(tempList)
    elif key == key_lst[2]:
        return get_memory(tempList)
    elif key == key_lst[3]:
        return get_os(tempList)
    elif key == key_lst[4]:
        return get_multipath(tempList)
    elif key == key_lst[5]:
        return get_clusternames(tempList)
    elif key == key_lst[6]:
        return get_lvm(tempList)
    elif key == key_lst[7]:
        return get_database(tempList)
    else:
        return "Key Error"

class Multipath_Entity:
    __mul_name = 'NA'
    __mul_version = 'NA'
    __mul_status = 'NA'
    
    def get_name(self):
        return self.__mul_name
    def get_version(self):
        return self.__mul_version
    def get_status(self):
        return self.__mul_status
    
    def set_name(self, name):
        self.__mul_name = name
    def set_version(self, version):
        self.__mul_version = version
    def set_status(self, status):
        self.__mul_status = status

class Cluster_Info:
    __name = 'NA'
    __version = 'NA'
    __status = 'NA'
    #set
    def set_name(self, name):
        self.__name = name
    def set_version(self, ver):
        self.__version = ver
    def set_status(self, status):
        self.__status = status
    #get
    def get_name(self):
        return self.__name
    def get_version(self):
        return self.__version
    def get_status(self):
        return self.__status  

