# --*-- coding:utf-8 --*--
import sys 
import os
import re
from cmd import Cmd
reload(sys) 
sys.setdefaultencoding('utf-8')
path = os.path.dirname(os.path.abspath(__file__))
path = os.path.join(path, "..\\..\\..")
sys.path.append(path)
from common.contentParse import *

global key_lst  #对应Excel中属性列表
global attribute_arr #从传入的命令中获取的属性列表 
global  value_lst
global context

#对应excel中的属性字段
key_lst  = [
                     'multipath_name', 
                     'multipath_version',
                     'multipath_status'
            ]

#获取Linux主机集群 Server信息
def execute(context):
    #获取回文
    #start
    path = getValueFMap(context,style,'path')
    command = getValueFMap(context,style,'command').strip()
    attribute_arr = []
    value_lst = []
    if ';'== command[-1]:
        command =command[0:-1]
    addValueToMap(context,style,'command',command)
    #属性名与对应命令组成的列表的字典
    attrcom_dic = get_attrcom_dic(context)
    #对应execel属性名
    json_attr_name = get_jsonarr_name(attrcom_dic)
    attr_valuelst_dic = get_attrvalue_dic(context,attrcom_dic)
    #获取attribute ,value_lst
    
    multipath = getValueFMap(attr_valuelst_dic, style, key_lst[0])
    
    multipathObj = get_multipath(multipath)
    
    value_lst.append(multipathObj.get_name())
    value_lst.append(multipathObj.get_version())
    value_lst.append(multipathObj.get_status())
    
    for key in key_lst:
        tempList = []
        for attr in attr_valuelst_dic.keys():
            if key.lower().strip() in attr.lower():
                attribute_arr.append(attr)

    #获取json结果字符串                
    result = get_jsonstr(json_attr_name,attribute_arr, value_lst)
    addValueToMap(context,style,'result',result)
    return context

def get_attrvalue_dic(context,attrcom_dic):
    all_comds_lst = get_purecommands_lst(attrcom_dic)
    path = getValueFMap(context,style,'path')
    all_comds_byfile = get_comdslst_byfile(all_comds_lst,path)
    return get_attrlst_dic(attrcom_dic,all_comds_byfile,path)


#功能说明：返回多路径名字
def get_multipath(tempList):
    mulObj = multipath_Entity()
    if 0 == len(tempList):
        return mulObj
    txtList = []
    index = 0
    for i,line in enumerate(tempList):
        if divide in line:
            txtList.append(tempList[index:i])
            index = i + 1
    failStr = fail_flag
    resultTxt = []
    for txtBlock in txtList:
        flag = True
        for line in txtBlock:
            if failStr.lower() in line.lower():
                flag = False
                break
        if flag:
            resultTxt = txtBlock
            
    if len(resultTxt) == 0:
        return mulObj
    
    for line in resultTxt:
        if ('powermt' in line) and ('version' in line):
            mulObj.set_name('PowerPath')
        if 'emc' in line.lower() and 'powermt' in line.lower():
            mulObj.set_version(line)
            return mulObj
    return mulObj


def get_value_bykey(tempList,key):
    if key == key_lst[0]:
        return get_multipath_name(tempList)
    elif key == key_lst[1]:
        return get_multipath_version(tempList)
    elif key == key_lst[2]:
        return get_multipath_status(tempList)
    else:
        return "Key Error"

class multipath_Entity:
    __mul_name = 'NA'
    __mul_version = 'NA'
    __mul_status = 'NA'
    
    def get_name(self):
        return self.__mul_name
    def get_version(self):
        return self.__mul_version
    def get_status(self):
        return self.__mul_status
    
    def set_name(self,name):
        self.__mul_name = name
    def set_version(self,version):
        self.__mul_version = version
    def set_status(self,status):
        self.__mul_status = status
