# coding=utf-8
__author__ = '******'
# 获取fusionsphere主机基本信息
import os
import re
import sys
path = os.path.dirname(os.path.abspath(__file__))
path =os.path.join(path, "..\\..")
sys.path.append(path)
from common.contentParse import getCommandRet
from common import constants
from common import util

cmd_info_id = ["cmd_info_os_basic_uname",
               "cmd_info_os_basic_issue",
               "cmd_info_os_basic_release",
               "cmd_info_os_basic_cpu",
               "cmd_info_os_basic_mem",
               "cmd_info_os_basic_date",
               "cmd_info_os_basic_passwd",
               "cmd_info_os_basic_manufacturer",
               "cmd_info_os_basic_vcfg",
               "cmd_info_os_basic_openstack"]
            
cmd_info_desc = ["uname -a",
                 "cat /etc/issue",
                 "cat /etc/*-release",
                 "cat /proc/cpuinfo",
                 "cat /proc/meminfo",
                 "date",
                 "cat /etc/passwd",
                 "dmidecode -s system-manufacturer",
                 "cat /opt/galax/version/GalaxVersion.cfg",
                 "cat /etc/hostos.version"]

def execute(context):
    context["totalPgr"]= constants.PROG70
    cmd_display = context.get("ret_map")
    cmd_display = getCommandRet(context,cmd_info_id,cmd_info_desc)
    util.updateItemProgress(context, constants.PROG90)
    return cmd_display