# --*-- coding:utf-8 --*--
import sys 
import os
import re
from cmd import Cmd
reload(sys) 
sys.setdefaultencoding('utf-8')
path = os.path.dirname(os.path.abspath(__file__))
path = os.path.join(path, "..\\..\\..")
sys.path.append(path)
from common.contentParse import *

global key_lst  #对应Excel中属性列表
global attribute_arr #从传入的命令中获取的属性列表 
global  value_lst
global context

#对应excel中的属性字段
key_lst  = [
                     'multipath_name', 
                     'multipath_version',
                     'multipath_status'
            ]

#获取Linux主机集群 Server信息
def execute(context):
    #获取回文
    #start
    path = getValueFMap(context,style,'path')
    command = getValueFMap(context,style,'command').strip()
    attribute_arr = []
    value_lst = []
    if ';'== command[-1]:
        command =command[0:-1]
    addValueToMap(context,style,'command',command)
    #属性名与对应命令列表组成的字典
    attrcom_dic = get_attrcom_dic(context)
    #对应execel属性名
    json_attr_name = get_jsonarr_name(attrcom_dic)
    #属性名与对应回文组成的字典
    attr_valuelst_dic = get_attrvalue_dic(context,attrcom_dic)
    #获取attribute ,value_lst
    for key in key_lst:
        for attr in attr_valuelst_dic.keys():
            if key.lower().strip() in attr.lower():
                attribute_arr.append(attr)
    #多路径对象lst
    multipath_lst = getValueFMap(attr_valuelst_dic, style, key_lst[0])
    txtblock_lst = get_eachmulti_lst(multipath_lst)
    obj_lst = get_mulobj_lst(txtblock_lst)
    #求多路径状态
    status_lst = getValueFMap(attr_valuelst_dic, style, key_lst[2])
    statu_value_lst = get_status(status_lst)
    #有某多路径，才放入某多路径的状态
    for mul in obj_lst:
        if mul.get_name().lower() == 'Multipath'.lower():
            try:
                mul.set_status(statu_value_lst[0])
            except:
                pass
            continue
        if mul.get_name().lower() == 'UltraPath'.lower():
            try:
                mul.set_status(statu_value_lst[1])
            except:
                pass
            continue
        if mul.get_name().lower() == 'PowerPath'.lower():
            try:
                mul.set_status(statu_value_lst[2])
            except:
                pass
    #获取json结果字符串  
    for multipathObj in obj_lst:
        value_lst.append(multipathObj.get_name())
        value_lst.append(multipathObj.get_version())
        value_lst.append(multipathObj.get_status())
                  
    result = get_jsonstr(json_attr_name,attribute_arr, value_lst)
    addValueToMap(context,style,'result',result)
    return context

#功能说明：返回属性名与对应回文组成的字典
def get_attrvalue_dic(context,attrcom_dic):
    all_comds_lst = get_purecommands_lst(attrcom_dic)
    path = getValueFMap(context,style,'path')
    all_comds_byfile = get_comdslst_byfile(all_comds_lst,path)
    return get_attrlst_dic(attrcom_dic,all_comds_byfile,path)


#功能说明：返回单个命令组的回文列表组成的列表
def get_eachmulti_lst(tempList):
    index = 0 
    txtList = []
    for i,line in enumerate(tempList):
        if divide in line:
            txtList.append(tempList[index:i+1])
            index = i+1 
    return txtList

##功能说明：返回多路径对象集合
def get_mulobj_lst(mulBlock_lst):
    failStr = "TOOLKIT_EXE_CMD_FAILED"
    block_lst = []
    mulobj_lst = []
    #过滤掉失败的段
    for block in mulBlock_lst:
        if  is_success(block):
            block_lst.append(block)
    for block in block_lst:
        mulObj = Multipath_Entity()
        for j,line in enumerate(block):
            #PowerPath : name ,version
            if ('powermt' in line.lower())and ('version' in line.lower())and('_' not in line):
                mulObj.set_name('PowerPath')
                if len(block) > j+1:
                    version = block[j+1].strip()
                    mulObj.set_version(version)
                else:
                    mulObj.set_version('NA')
                break
            #UltraPath
            elif ('upadmin' in line.lower()) and ('show' in line.lower()):
                mulObj.set_name('UltraPath')
                #UltraPath version
                for vline in block[j:]:
                    if ('version' in vline.lower()) and ('software' in vline.lower()):
                        tempArr = re.split('\\s+', vline)
                        mulObj.set_version(tempArr[3])
                        break
                break
            #HDLM
            elif 'dlnkmgr' in line:
                mulObj.set_name('HDLM')
                break
            #UltraPath
            elif ('upadm' in line.lower()) and ('show' in line.lower()):
                mulObj.set_name('UltraPath')
                break
            #Multipath
            elif ('multipath' in line.lower()) and ('ll' in line.lower()):
                mulObj.set_name('Multipath')
                break
            else:
                pass
        mulobj_lst.append(mulObj)
    return mulobj_lst


#****************************************
#函数名称:get_status
#功能说明:获取多路径状态
#获取方法：
#cmd_display_multipath_multipath -> Multipath
#cmd_display_multipath_status_phypath -> UltraPath
#cmd_display_multipath_powermt_display -> PowerPath
#****************************************
def get_status(status_lst):
    sta_lst = []
    status_value_lst =[]
    index = 0 
    for i,line in enumerate(status_lst):
        if divide in line.lower():
            sta_lst.append(status_lst[index:i+1])
            index = i+1
    for j,templst in enumerate(sta_lst):
        #若失败则为NA
        if not is_success(templst):
            status = 'NA'
        else:
            status = '\\n'.join(templst[2:-1])
            if "" == status.strip():
                status = 'NA'
        status_value_lst.append(status)
    return status_value_lst
            

class Multipath_Entity:
    __mul_name = 'NA'
    __mul_version = 'NA'
    __mul_status = 'NA'
    
    def get_name(self):
        return self.__mul_name
    def get_version(self):
        return self.__mul_version
    def get_status(self):
        return self.__mul_status
    
    def set_name(self,name):
        self.__mul_name = name
    def set_version(self,version):
        self.__mul_version = version
    def set_status(self,status):
        self.__mul_status = status
