# --*-- coding:utf-8 --*--
import sys 
import os
import re
from cmd import Cmd
reload(sys) 
sys.setdefaultencoding('utf-8')
path = os.path.dirname(os.path.abspath(__file__))
path = os.path.join(path, "..\\..\\..")
sys.path.append(path)
from common.contentParse import *

global divide
global key_lst  #对应Excel中属性列表
global attribute_arr #从传入的命令中获取的属性列表 
global  value_lst
global context
global tempList
global hba_obj

#对应excel中的属性字段
key_lst  = [
                     'hba_instance', 
                     'hba_model',
                     'wwn',
                     'status'
            ]

#获取Linux主机集群 Server信息
def execute(context):
    #获取回文
    #start
    path = getValueFMap(context,style,'path')
    command = getValueFMap(context,style,'command').strip()
    attribute_arr = []
    value_lst = []
    tempList = []
    
    addValueToMap(context,style,'command',command)
    #属性名与对应命令列表组成的字典
    attrcom_dic = get_attrcom_dic(context)
    #对应execel属性名
    json_attr_name = get_jsonarr_name(attrcom_dic)
    attr_valuelst_dic = get_attrvalue_dic(context,attrcom_dic)
    #获取attribute ,value_lst
    for key in key_lst:
        for attr in attr_valuelst_dic.keys():
            if key.lower().strip() in attr.lower():
                attribute_arr.append(attr)
                tempList = attr_valuelst_dic[attr]
                break 
                #这里四个属性值的命令描述都一样
    for h in tempList:
        if ('hba' in h.lower()) and ('port' in h.lower()) and ('wwn' in h.lower()):
            hba_obj = Hba_Entity()
            hbawwn = h.split(':')[-1].strip()
            hba_obj.set_wwn(hbawwn)
            continue
        elif 'model' in h.lower():
            model = h.split(':')[-1].strip()
            hba_obj.set_model(model)
            continue
        elif ('os' in h.lower()) and ('device' in h.lower()) and ('name' in h.lower()):
            name = h.split(':')[-1].strip()
            hba_obj.set_instance(name)
            continue
        elif 'state' in h.lower():
            state = h.split(':')[-1].strip()
            hba_obj.set_status(state)
            value_lst.append(hba_obj)
   
    result_lst = []
    for h_obj in value_lst:
        result_lst.append(h_obj.get_instance())
        result_lst.append(h_obj.get_model())
        result_lst.append(h_obj.get_wwn())
        result_lst.append(h_obj.get_status())
    value_lst = result_lst
    #获取json结果字符串                
    result = get_jsonstr(json_attr_name,attribute_arr, value_lst)
    addValueToMap(context,style,'result',result)
    return context

#功能说明：返回属性名与对应回文组成的字典
def get_attrvalue_dic(context,attrcom_dic):
    all_comds_lst = get_purecommands_lst(attrcom_dic)
    path = getValueFMap(context,style,'path')
    all_comds_byfile = get_comdslst_byfile(all_comds_lst,path)
    return get_attrlst_dic(attrcom_dic,all_comds_byfile,path)


class Hba_Entity:
    __hba_instance = 'NA'
    __hba_model = 'NA'
    __hba_wwn = 'NA'
    __hba_status  = 'NA'
    
    def get_instance(self):
        return self.__hba_instance
     
    def get_model(self):
        return self.__hba_model 
    def get_wwn(self):
        return self.__hba_wwn 
    def get_status(self):
        return self.__hba_status
    def set_instance(self,ins):
        self.__hba_instance = ins
    
    def set_model(self,model):
        self.__hba_model = model
    
    def set_wwn(self,wwn):
        self.__hba_wwn  = wwn
        
    def set_status(self,status):
        self.__hba_status =status
