# --*-- coding:utf-8 --*--
import sys 
import os
import re
from cmd import Cmd
reload(sys) 
sys.setdefaultencoding('utf-8')
path = os.path.dirname(os.path.abspath(__file__))
path = os.path.join(path, "..\\..\\..")
sys.path.append(path)
from common.contentParse import *

global key_lst  #对应Excel中属性列表
global attribute_arr #从传入的命令中获取的属性列表 
global  value_lst
global context
global disk_obj

#对应excel中的属性字段
key_lst  = [
                     'device', 
                     'vendor',
                     'capacity',
                     'lunwwn',
                     'pv_name',
                     'vg_name'
            ]


#获取Linux主机集群 Server信息
def execute(context):
    #获取回文
    #start
    path = getValueFMap(context,style,'path')
    command = getValueFMap(context,style,'command').strip()
    attribute_arr = []
    value_lst = []
    addValueToMap(context,style,'command',command)
    #属性名与对应命令列表组成的字典
    attrcom_dic = get_attrcom_dic(context)
    #对应execel属性名
    json_attr_name = get_jsonarr_name(attrcom_dic)
    attr_valuelst_dic = get_attrvalue_dic(context,attrcom_dic)
    #获取attribute  
    for key in key_lst:
        for attr in attr_valuelst_dic.keys():
            if key.lower().strip() in attr.lower():
                attribute_arr.append(attr)
    tempLst = attr_valuelst_dic[key_lst[0]]
    disk_obj_lst = []
    
    for temp in tempLst:
        if ('display' in temp.lower()) and ('name' in temp.lower()) and ('(' in temp.lower()):
            disk_obj = Disk_Entity()
            lst = temp.split('(')
            result = lst [-1][0:-1]
            disk_obj.set_device(result)
            continue
        elif 'vendor' in temp.lower():
            result = temp.split(':')[1].strip()
            disk_obj.set_vendor(result)
            continue
        elif ('size' in temp.lower()) and ('sample' not in temp.lower()):
            result = temp.split(':')[1].strip()
            result = float(result)
            result = result/1024.0
            result = round(result,2)
            result = str(result)+' GB'
            disk_obj.set_capacity(result)
            continue
        elif ('other' in temp.lower()) and ('uids' in temp.lower()):
            result = temp.split(':')[1].strip()
            disk_obj.set_wwn(result)
            disk_obj_lst.append(disk_obj)
    
    #求value_lst
    for temp_obj in disk_obj_lst:
        value_lst.append(temp_obj.get_device())
        value_lst.append(temp_obj.get_vendor())
        value_lst.append(temp_obj.get_capacity())
        value_lst.append(temp_obj.get_wwn())
        value_lst.append(temp_obj.get_pvname())
        value_lst.append(temp_obj.get_vgname())
    #获取json结果字符串                
    result = get_jsonstr(json_attr_name,attribute_arr, value_lst)
    addValueToMap(context,style,'result',result)
    return context

#功能说明：返回属性名与对应回文组成的字典
def get_attrvalue_dic(context,attrcom_dic):
    all_comds_lst = get_purecommands_lst(attrcom_dic)
    path = getValueFMap(context,style,'path')
    all_comds_byfile = get_comdslst_byfile(all_comds_lst,path)
    return get_attrlst_dic(attrcom_dic,all_comds_byfile,path)


class Disk_Entity:
    __disk_device = 'NA'
    __disk_vendor = 'NA'
    __disk_capacity = 'NA'
    __disk_wwn = 'NA'
    __disk_pvname = 'NA'
    __disk_vgname = 'NA'
    def get_device(self):
        return self.__disk_device
    def get_vendor(self):
        return self.__disk_vendor
    def get_capacity(self):
        return self.__disk_capacity
    def get_wwn(self):
        return self.__disk_wwn
    def get_pvname(self):
        return self.__disk_pvname
    def get_vgname(self):
        return self.__disk_vgname
    def set_device(self,device):
        self.__disk_device = device
    def set_vendor(self,vendor):
        self.__disk_vendor = vendor
    def set_capacity(self,cap):
        self.__disk_capacity = cap
    def set_wwn(self,wwn):
        self.__disk_wwn
    def set_pvname(self,pvname):
        self.__disk_pvname = pvname
    def set_vgname(self,vgname):
        self.__disk_vgname = vgname
 
