# --*-- coding:utf-8 --*--
import sys
import os
import re
from cmd import Cmd

reload(sys)
sys.setdefaultencoding('utf-8')
path = os.path.dirname(os.path.abspath(__file__))
path = os.path.join(path, "..\\..\\..")
sys.path.append(path)
from common.contentParse import *

global key_lst  # 对应Excel中属性列表
global attribute_arr  # 从传入的命令中获取的属性列表
global value_lst
global context

# 对应excel中的属性字段
key_lst = [
    'mapping_view_id', 'mapping_view_name', 'host_group_id', 'host_group_name', 'host_id', 'host_name', 'host_type',
    'initiator_wwn', 'port'
]


# 获取Linux主机集群 Server信息
def execute(context):
    # 获取回文
    # start
    path = getValueFMap(context, style, 'path')
    command = getValueFMap(context, style, 'command').strip()
    attribute_arr = []
    value_lst = []

    addValueToMap(context, style, 'command', command)
    attrcom_dic = get_attrcom_dicv2(context)
    # 对应execel属性名
    json_attr_name = get_jsonarr_name(attrcom_dic)
    attr_valuelst_dic = get_attrvalue_dic(context, attrcom_dic)

    # 获取attribute ,value_lst
    for key in key_lst:
        for attr in attr_valuelst_dic.keys():
            if key.lower().strip() in attr.lower():
                attribute_arr.append(attr)
    hostid = attr_valuelst_dic.get('host_id')
    lun = attr_valuelst_dic.get('host_group_id')

    if is_success(hostid) and is_success(lun):
        hostvalue_list = get_hostset_info(hostid, lun)
        hostobj = hostset_Entity()
        for hostobj in hostvalue_list:
            value_lst.append('NA')
            value_lst.append('NA')
            value_lst.append(str(hostobj.get_hostgroupid()))
            value_lst.append(str(hostobj.get_hostgroupname()))
            value_lst.append(hostobj.get_hostid())
            value_lst.append(hostobj.get_hostname())
            value_lst.append(hostobj.get_hosttype())
            value_lst.append(hostobj.get_hostwwn())
            value_lst.append('NA')
    else:
        value_lst = ['NA', 'NA', 'NA', 'NA', 'NA', 'NA', 'NA', 'NA', 'NA']
    # 获取json结果字符串

    result = get_jsonstr(json_attr_name, attribute_arr, value_lst)
    addValueToMap(context, style, 'result', result)
    return context


# 获取storage group 对象集合
def get_hostset_info(txt_hostid, txt_lun):
    hostlist = []

    # 获取{hostid:lun[],.....}
    dic = {}
    for line in txt_lun[3:-1]:
        items = line.split(":")
        if items[0] in dic:
            dic[items[0]].append(items[3])
        else:
            dic[items[0]] = [items[3]]


    #修改dic  {hostid:{hostgid,hostgname},.....}
    hostgid = 0
    for i in dic:
        if type(dic[i]) != type([]):
            continue
        hostgid = hostgid + 1
        hostgname = "HostGroup" + str(hostgid)
        listTemp = dic[i]
        dic[i] = {"hostgid": hostgid, "hostgname": hostgname}
        for j in dic:
            if type(dic[j]) != type([]):
                continue
            if len(list(set(listTemp).difference(set(dic[j])))) == 0 and len(
                    list(set(dic[j]).difference(set(listTemp)))) == 0:
                dic[j] = {"hostgid": hostgid, "hostgname": hostgname}

    for line in txt_hostid:
        if ">lshost -delim :" in line.lower():
            hostobj = hostset_Entity()
            num = 0
        if line.lower().startswith("id:"):
            id = re.split(":", line)[1]
            hostobj.set_hostid(id)
            hostobj.set_hostgroupid(dic[id]["hostgid"])
            hostobj.set_hostgroupname(dic[id]["hostgname"])
        if line.lower().startswith("name:"):
            hostobj.set_hostname(re.split(":", line)[1])
        if line.lower().startswith("type:"):
            hostobj.set_hosttype(re.split(":", line)[1])
            hostlist.append(hostobj)
        if line.lower().startswith("wwpn:"):
            if num == 0:  # 第一次获取wwpn
                del hostlist[-1]
            num = num + 1
            hostobj.set_hostwwn(re.split(":", line)[1])
            hostlist.append(hostobj)
            hostobjTemp = hostobj
            hostobj = hostset_Entity()
            hostobj.set_hostid(hostobjTemp.get_hostid())
            hostobj.set_hostgroupid(hostobjTemp.get_hostgroupid())
            hostobj.set_hostgroupname(hostobjTemp.get_hostgroupname())
            hostobj.set_hostname(hostobjTemp.get_hostname())
            hostobj.set_hosttype(hostobjTemp.get_hosttype())
    return hostlist


def get_attrvalue_dic(context, attrcom_dic):
    all_comds_lst = get_purecommands_lst(attrcom_dic)
    path = getValueFMap(context, style, 'path')
    all_comds_byfile = get_comdslst_byfile(all_comds_lst, path)
    return get_attrlst_dic(attrcom_dic, all_comds_byfile, path)


def get_attrcom_dicv2(context):
    command = getValueFMap(context, style, 'command')
    # 去除最后面的';'
    if ';' == command.strip()[-1]:
        command = command[0:-1]
    attrcom_dic = {}
    try:
        for comd in command.split(';'):
            if comd.count(':') == 1:
                lst = comd.split(':')
                key = lst[0].strip()
                if (1 < len(lst)) and (',' in lst[1]):
                    addValueToMap(attrcom_dic, style, key, lst[1].strip().split(','))
                else:
                    addValueToMap(attrcom_dic, style, key, [lst[1].strip()])
            else:
                value_lst = comd.split(':')
                key = value_lst[0].strip()
                rep = key + ':'
                value = comd.replace(rep, '')
                value = value.strip()
                addValueToMap(attrcom_dic, style, key, [value])
    except:
        raise Exception("Not Leagal ,this commands..")
    return attrcom_dic


class hostset_Entity:
    __hostgroup_id = 'NA'
    __hostgroup_name = 'NA'
    __hostid = 'NA'
    __hostname = 'NA'
    __hosttype = 'NA'
    __hostwwn = 'NA'
    __port = 'NA'

    # get

    def get_hostgroupid(self):
        return self.__hostgroup_id

    def get_hostgroupname(self):
        return self.__hostgroup_name

    def get_hostid(self):
        return self.__hostid

    def get_hostname(self):
        return self.__hostname

    def get_hosttype(self):
        return self.__hosttype

    def get_hostwwn(self):
        return self.__hostwwn

    def get_port(self):
        return self.__port

    # set
    def set_hostgroupid(self, hostgroupid):
        self.__hostgroup_id = hostgroupid

    def set_hostgroupname(self, hostgroupname):
        self.__hostgroup_name = hostgroupname

    def set_hostid(self, hostid):
        self.__hostid = hostid

    def set_hostname(self, hostname):
        self.__hostname = hostname

    def set_hosttype(self, hosttype):
        self.__hosttype = hosttype

    def set_hostwwn(self, wwn):
        self.__hostwwn = wwn

    def set_port(self, port):
        self.__port = port
