# --*-- coding:utf-8 --*--
import sys
import os
import re
from cmd import Cmd

reload(sys)
path = os.path.dirname(os.path.abspath(__file__))
path = os.path.join(path, "..\\..\\..")
sys.path.append(path)
from common.contentParse import *

global key_lst  # 对应Excel中属性列表
global attribute_arr  # 从传入的命令中获取的属性列表
global value_lst
global context

# 对应excel中的属性字段
key_lst = [
    'report_date/time',
    'infograb_version',
    'storage_model',
    'storage_firmware',
    'storage_serial',
    'ip_address'
]


# 获取Linux主机集群 Server信息
def execute(context):
    # 获取回文
    # start
    path = getValueFMap(context, style, 'path')
    command = getValueFMap(context, style, 'command').strip()
    attribute_arr = []
    value_lst = []

    addValueToMap(context, style, 'command', command)
    attrcom_dic = get_attrcom_dic(context)
    # 对应execel属性名
    json_attr_name = get_jsonarr_name(attrcom_dic)

    attr_valuelst_dic = get_attrvalue_dic(context, attrcom_dic)
    # 获取attribute_arr
    for key in key_lst:
        for attr in attr_valuelst_dic.keys():
            if key.lower().strip() in attr.lower():
                attribute_arr.append(attr)

    # storage_model
    storage_model = 'NA'
    model_lst = attr_valuelst_dic[attribute_arr[2]]
    storage_model = get_model(model_lst)

    # storage_serial
    storage_serial = 'NA'
    serial_lst = attr_valuelst_dic[attribute_arr[4]]
    storage_serial = get_serial(serial_lst)

    value_lst = ['NA', 'NA', storage_model, 'NA', storage_serial, 'NA']
    # 获取json结果字符串
    result = get_jsonstr(json_attr_name, attribute_arr, value_lst)
    addValueToMap(context, style, 'result', result)
    return context


# storage_model
def get_model(linelst):
    result = "NA"
    for line in linelst:
        if line.startswith("product_mtm:"):
            result = "IBM_" + (line.split(":")[1]).split("-")[0]
            break
    return result;


# storage_serial
def get_serial(linelst):
    result = "NA"
    for line in linelst:
        if line.startswith("id:"):
            result = line.split(":")[1]
            break
    return result;


def get_attrvalue_dic(context, attrcom_dic):
    all_comds_lst = get_purecommands_lst(attrcom_dic)
    path = getValueFMap(context, style, 'path')
    all_comds_byfile = get_comdslst_byfile(all_comds_lst, path)
    return get_attrlst_dic(attrcom_dic, all_comds_byfile, path)
