# --*-- coding:utf-8 --*--
import sys
import os
reload(sys)
path = os.path.dirname(os.path.abspath(__file__))
path = os.path.join(path, '..\\..\\..')
sys.path.append(path)
from common.contentParse import handel_xml_info
from common.contentParse import is_success
from common.contentParse import addValueToMap
from common.contentParse import get_jsonstr
from common.contentParse import style
from common.contentParse import get_xml_lst
from common.contentParse import get_xml_item
from common.contentParse import handle_translation_char
global key_lst  #对应Excel中属性列表
global attribute_arr #从传入的命令中获取的属性列表
global  value_lst
global context
#对应excel中的属性字段
key_lst  = ['share-name',
            'user-name',
            'access-rights']

def execute(context):
    attr_valuelst_dic, json_attr_name, attribute_arr = handel_xml_info(context, key_lst)
    value_lst = []
    share_name = attr_valuelst_dic.get('share-name')
    if share_name and is_success(share_name):
        value_lst.extend(get_set_info(share_name))
    #获取json结果字符串
    result = get_jsonstr(json_attr_name, attribute_arr, value_lst)
    addValueToMap(context, style, 'result', result)
    return context

def get_set_info(set_msg):
    set_msg_all = ''.join(set_msg)
    cifs_share_acl_info = get_xml_lst(set_msg_all, 'cifs-share-acl-info')
    obj_lst = []
    for info_obj in cifs_share_acl_info:
        share_name = handle_translation_char(get_xml_item(info_obj, 'share-name'))
        access_rights_info = get_xml_lst(info_obj, 'access-rights-info')
        for ari in access_rights_info:
            user_name = get_xml_item(ari, 'user-name')
            access_rights = get_xml_item(ari, 'access-rights')
            obj_lst.extend([share_name, user_name, access_rights])
    return obj_lst




