# --*-- coding:utf-8 --*--
import sys
import os
reload(sys)
path = os.path.dirname(os.path.abspath(__file__))
path = os.path.join(path, "..\\..\\..")
sys.path.append(path)
from common.contentParse import handel_xml_info
from common.contentParse import is_success
from common.contentParse import get_jsonstr
from common.contentParse import addValueToMap
from common.contentParse import style
from common.contentParse import get_xml_lst
from common.contentParse import get_xml_item
global key_lst  #对应Excel中属性列表
global attribute_arr #从传入的命令中获取的属性列表
global  value_lst
global context
#对应excel中的属性字段
key_lst  = ['quota-type',
            'quota-target',
            'volume',
            'qtree',
            'disk-used',
            'disk-limit',
            'soft-disk-limit',
            'threshold',
            'files-used',
            'file-limit',
            'soft-file-limit',
            'vfiler',
            'quota-user-type',
            'quota-user-id',
            'quota-user-name']

def execute(context):
    attr_valuelst_dic, json_attr_name, attribute_arr = handel_xml_info(context, key_lst)
    value_lst = []
    quota_type = attr_valuelst_dic.get('quota-type')
    if quota_type and is_success(quota_type):
        value_lst.extend(get_set_info(quota_type))
    result = get_jsonstr(json_attr_name,attribute_arr, value_lst)
    addValueToMap(context, style, 'result', result)
    return context

def get_set_info(set_msg):
    set_msg_all = "".join(set_msg)
    quota_info = get_xml_lst(set_msg_all , 'quota-info')
    obj_lst = []
    for info_obj in quota_info:
        quota_type = get_xml_item(info_obj, 'quota-type')
        quota_target = get_xml_item(info_obj, 'quota-target')
        volume = get_xml_item(info_obj, 'volume')
        qtree = get_xml_item(info_obj, 'qtree')
        disk_used = get_xml_item(info_obj, 'disk-used')
        disk_limit = get_xml_item(info_obj, 'disk-limit')
        soft_disk_limit = get_xml_item(info_obj, 'soft-disk-limit')
        threshold = get_xml_item(info_obj, 'threshold')
        files_used = get_xml_item(info_obj, 'files-used')
        file_limit = get_xml_item(info_obj, 'file-limit')
        soft_file_limit = get_xml_item(info_obj, 'soft-file-limit')
        vfiler = get_xml_item(info_obj, 'vfiler')
        quota_users = get_xml_lst(info_obj, 'quota-users')
        if len(quota_users) > 0:
            for qus in quota_users:
                for _user in get_xml_lst(qus, 'quota-user'):
                    quota_user_type = get_xml_item(_user, 'quota-user-type')
                    quota_user_id = get_xml_item(_user, 'quota-user-id')
                    quota_user_name = get_xml_item(_user, 'quota-user-name')
                    obj_lst.extend([quota_type, quota_target, volume, qtree, disk_used,
                                   disk_limit, soft_disk_limit, threshold, files_used,
                                   file_limit, soft_file_limit, vfiler, quota_user_type,
                                   quota_user_id, quota_user_name])
        else:
            obj_lst.extend([quota_type, quota_target, volume, qtree, disk_used,
                           disk_limit, soft_disk_limit, threshold, files_used,
                           file_limit, soft_file_limit, vfiler, '', '', ''])
    return obj_lst

