# --*-- coding:utf-8 --*--
import sys
import os
reload(sys)
path = os.path.dirname(os.path.abspath(__file__))
path = os.path.join(path, "..\\..\\..")
sys.path.append(path)
from common.contentParse import handel_xml_info
from common.contentParse import is_success
from common.contentParse import get_jsonstr
from common.contentParse import addValueToMap
from common.contentParse import style
from common.contentParse import get_xml_lst
from common.contentParse import get_xml_item
global key_lst  # 对应Excel中属性列表
global attribute_arr  # 从传入的命令中获取的属性列表
global value_lst
global context

# 对应excel中的属性字段
key_lst = [ 'anonymous-user-id',
            'client-match',
            'export-chown-mode',
            'export-ntfs-unix-security-ops',
            'is-allow-dev-is-enabled',
            'is-allow-set-uid-enabled',
            'policy-name',
            'protocol',
            'ro-rule',
            'rule-index',
            'rw-rule',
            'super-user-security',
            'vserver-name']

def execute(context):
    attr_valuelst_dic, json_attr_name, attribute_arr = handel_xml_info(context, key_lst)
    value_lst = []
    anonymous_user_id = attr_valuelst_dic.get('anonymous-user-id')
    if anonymous_user_id and is_success(anonymous_user_id):
        value_lst.extend(get_set_info(anonymous_user_id))
    # 获取json结果字符串
    result = get_jsonstr(json_attr_name, attribute_arr, value_lst)
    addValueToMap(context, style, 'result', result)
    return context


def get_set_info(set_msg):
    set_msg_all = ''.join(set_msg)
    export_rule_info = get_xml_lst(set_msg_all, 'export-rule-info')
    obj_lst = []
    for info_obj in export_rule_info:
        anonymous_user_id = get_xml_item(info_obj, 'anonymous-user-id')
        client_match = get_xml_item(info_obj, 'client-match')
        export_chown_mode = get_xml_item(info_obj, 'export-chown-mode')
        export_ntfs_unix_security_ops = get_xml_item(info_obj, 'export-ntfs-unix-security-ops')
        is_allow_dev_is_enabled = get_xml_item(info_obj, 'is-allow-dev-is-enabled')
        is_allow_set_uid_enabled = get_xml_item(info_obj, 'is-allow-set-uid-enabled')
        policy_name = get_xml_item(info_obj, 'policy-name')
        protocol = ''
        for _p in get_xml_lst(info_obj, 'access-protocol'):
            protocol += get_xml_item(_p, 'access-protocol') + ','
        ro_rule_item = get_xml_lst(info_obj, 'ro-rule')
        ro_rule = ''
        if len(ro_rule_item) > 0:
            ro_rule = get_xml_item(ro_rule_item[0], 'security-flavor')
        rule_index = get_xml_item(info_obj, 'rule-index')
        rw_rule_item = get_xml_lst(info_obj, 'rw-rule')
        rw_rule = ''
        if len(rw_rule_item) > 0:
            rw_rule = get_xml_item(rw_rule_item[0], 'security-flavor')
        super_user_security_item = get_xml_lst(info_obj, 'super-user-security')
        super_user_security = ''
        if len(super_user_security_item) > 0:
            super_user_security = get_xml_item(super_user_security_item[0], 'security-flavor')
        vserver_name = get_xml_item(info_obj, 'vserver-name')
        obj_lst.extend([anonymous_user_id, client_match, export_chown_mode,
                        export_ntfs_unix_security_ops, is_allow_dev_is_enabled,
                        is_allow_set_uid_enabled, policy_name, protocol, ro_rule,
                        rule_index, rw_rule, super_user_security, vserver_name])
    return obj_lst
