# --*-- coding:utf-8 --*--
import sys 
import os
import re
from cmd import Cmd
reload(sys)
path = os.path.dirname(os.path.abspath(__file__))
path = os.path.join(path, "..\\..\\..")
sys.path.append(path)
from common.contentParse import *

global key_lst  #对应Excel中属性列表
global attribute_arr #从传入的命令中获取的属性列表
global  value_lst
global context

#对应excel中的属性字段
key_lst  = [
                'report_date/time',
                'infograb_version',
                'storage_vendor',
                'system_version',
                'ip_address'
            ]

def execute(context):
    #获取回文
    #start
    path = context.get('path')
    command = context.get('command').strip()
    attribute_arr = []
    value_lst = []
    
    context['command'] = command
    attrcom_dic = get_attrcom_dic(context)
    #对应execel属性名
    json_attr_name = get_jsonarr_name(attrcom_dic)
   
    attr_valuelst_dic = get_attrvalue_dic(context, attrcom_dic)
    #获取attribute_arr
    for key in key_lst:
        for attr in attr_valuelst_dic.keys():
            if key.lower().strip() in attr.lower():
                attribute_arr.append(attr)
    
    #storage_vendor
    storage_vendor = 'NA'
    model_lst = attr_valuelst_dic[attribute_arr[2]]
    storage_vendor = get_model(model_lst)

    #system_version
    system_version = 'NA'
    version_lst = attr_valuelst_dic[attribute_arr[3]]
    system_version = get_version(version_lst)
    
    value_lst = ['NA', 'NA', storage_vendor, system_version, 'NA']
    #获取json结果字符串
    result = get_jsonstr(json_attr_name,attribute_arr, value_lst)
    addValueToMap(context,style,'result',result)
    return context

#storage_model
def get_model(model_lst):
    '''
    @summary: get device vendor name using on-tap api :system-get-version
    '''
    echos = ''.join(model_lst)
    result = "NA"
    charset_start = echos.find('<version>') + len('<version>') if echos.find('<version>') > 0 else -1
    charset_end = echos.find('</version>')  if echos.find('</version>') > 0 else -1
    if charset_start + charset_end > 0:
        substrs = echos[charset_start:charset_end]
        result = substrs.split()[0]
    return result;

#storage_firmware
def get_version(model_lst):
    '''
    @summary: get system version using on-tap api and parsing xml-pretty string
    '''
    echos = ''.join(model_lst)
    result = "NA"
    charset_start = echos.find('<version>') + len('<version>') if echos.find('<version>') > 0 else -1
    charset_end = echos.find('</version>')  if echos.find('</version>') > 0 else -1
    if charset_start + charset_end > 0:
        substrs = echos[charset_start:charset_end]
        result = substrs.split(':')[0]

    return result;

def get_attrvalue_dic(context,attrcom_dic):
    all_comds_lst = get_purecommands_lst(attrcom_dic)
    path = getValueFMap(context,style,'path')
    all_comds_byfile = get_comdslst_byfile(all_comds_lst,path)
    return get_attrlst_dic(attrcom_dic,all_comds_byfile,path)


